/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



namespace Khz{
        /**
        @brief classes and functions for  the bibtex database generation.
        Includes gui classes and non-gui classes
        **/
        namespace BibTex{




 /**
@brief Window displaying the bibtex entry for the book.

This window resizes itself to show the bibtex entry without scrollbars.
The window appears when user right clicks book and selects the "Gen Bibtex" entry in the popup menu.
**/
class BibtexEntryWindow : public wxFrame
    {
    public:
        /**
        Constructor
        @param parent standard wxwidgets parent
        @param Bibtex_wxString The full bibtex entry for the book. The string must be a full bibtex
        entry, it should have line breaks. The line breaks must be represented
        by the "\n" symbol.
        **/
        BibtexEntryWindow(wxWindow *parent, wxString Bibtex_wxString);
    private:
        /**
        Closes the window (when user presses the "Close" button)
        **/
        void OnClose(wxCommandEvent& event);
    };


}} //end of namespace
