/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <wx/log.h>
#include <wx/msgdlg.h>
#include "MySizeFunctions.h"
#include <wx/radiobut.h>
#include <wx/checkbox.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/statline.h>
#include <wx/filedlg.h>
#include <wx/filectrl.h>
//#include "MyFileDialog.h"
#include <wx/stdpaths.h>
#include "TreeCtrlLibrary.h"
#include "MyTopicSelectorDialog.h"
#include "clear_database_path.h"
#include "Mdb_fuctions.h"
//#include "MyGenBibtexEvent.h"
#include "MyleftPanel.h"
#include "MyMainWindow.h"
#include "BibTexGeneratorStandaloneWindow.h"
#include "Custom_IDs.h"
#include "get_books_from_db_by_query.h"
#include <wx/progdlg.h>
#include "BibtexTranslator.h"
#include <fstream>
#include "string_functions.h"
#include "ConfigManager.h"
//wxDEFINE_EVENT(myEVT_BIBTEX_GENERATION_WANTED, MyGenBibtexEvent);



namespace Khz{namespace BibTex{




BibTexGeneratorStandaloneWindow::BibTexGeneratorStandaloneWindow(wxWindow *parent)
    : wxFrame(parent, wxID_ANY, "Bibtex database generation")
    {
	wxPanel* main_panel=new wxPanel(this, wxID_ANY);

    //radiobuttons
    bibtex_gen_topic_radiobutton= new wxRadioButton(main_panel, wxID_ANY, "For books belonging to a topic");
    bibtex_gen_right_panel_radiobutton = new wxRadioButton(main_panel, wxID_ANY, "For books that are currently displayed on the right panel");
    bibtex_gen_right_panel_radiobutton->SetValue(true);
    bibtex_gen_all_radiobutton = new wxRadioButton(main_panel, wxID_ANY, "For all of the books");


    //checkbox
    include_subtopics_checkbox = new wxCheckBox(main_panel, wxID_ANY, "Including subtopics");
    include_subtopics_checkbox->Disable();

    //topic input
    input_for_topic= new wxTextCtrl(main_panel, wxID_ANY);
    input_for_topic->Disable();
    select_topic_button = new wxButton(main_panel, wxID_ANY, "Choose");
    select_topic_button->Disable();
    topic_text=new wxStaticText( main_panel, wxID_ANY, wxT("Topic"));
    topic_text->Disable();

    //where to save result input
    where_to_save_database_input = new wxTextCtrl(main_panel, wxID_ANY);
    select_path_for_result_button = new wxButton(main_panel, wxID_ANY, "Choose");

    //ok cancel buttons
    ok_button=new wxButton(main_panel, wxID_OK, "Generate bibtex");
    cancel_button=new wxButton(main_panel, wxID_CANCEL);




    wxBoxSizer *only_sizer = new wxBoxSizer (wxVERTICAL);

    //just a text
    wxStaticText *descr =new wxStaticText( main_panel, wxID_ANY,
                                 wxT("I want to generate a bibtex database for:"));
     wxFont font = descr->GetFont();
        font.SetWeight(wxFONTWEIGHT_BOLD);
        descr->SetFont(font);
    only_sizer->Add(descr, 0, wxALL,15);

    //books on right panel radiobutton
    only_sizer->Add(bibtex_gen_right_panel_radiobutton, 0, wxALL, 5);
    only_sizer->AddSpacer(20);

    //topic radiobutton
    only_sizer->Add(bibtex_gen_topic_radiobutton,0, wxALL, 5);
         wxBoxSizer *input_for_topic_sizer_outer_outer= new wxBoxSizer( wxHORIZONTAL );
            wxBoxSizer *input_for_topic_sizer_outer = new wxBoxSizer( wxVERTICAL );
                wxBoxSizer *input_for_topic_sizer = new wxBoxSizer( wxHORIZONTAL );
                input_for_topic_sizer->Add(input_for_topic,1, wxCENTRE | wxALL);
                input_for_topic_sizer->Add(select_topic_button);
            input_for_topic_sizer_outer->Add(topic_text, 0, wxEXPAND|wxALL);
            input_for_topic_sizer_outer->Add(input_for_topic_sizer, 1, wxALL|wxEXPAND);
            input_for_topic_sizer_outer->Add(include_subtopics_checkbox,0, wxALL|wxEXPAND);
        input_for_topic_sizer_outer_outer->AddSpacer(25);
        input_for_topic_sizer_outer_outer->Add(input_for_topic_sizer_outer,1, wxALL|wxEXPAND);
        input_for_topic_sizer_outer_outer->AddSpacer(5);
    only_sizer->Add(input_for_topic_sizer_outer_outer,0, wxALL|wxEXPAND);
    only_sizer->AddSpacer(20);


    //all books radiobutoon
    only_sizer->Add(bibtex_gen_all_radiobutton, 0, wxALL, 5);
    only_sizer->AddSpacer(20);
    only_sizer->Add(new wxStaticLine (main_panel),0, wxEXPAND|wxLEFT|wxRIGHT,5);
    only_sizer->AddSpacer(20);

    //where to save result input
        wxBoxSizer *where_to_store_final_db_sizer = new wxBoxSizer( wxVERTICAL );
        where_to_store_final_db_sizer->Add(new wxStaticText( main_panel, wxID_ANY, wxT("Specify where to save the generated bibtex database")), 0, wxEXPAND|wxALL);
            wxBoxSizer *where_to_store_final_db_sizer_inner = new wxBoxSizer( wxHORIZONTAL );
            where_to_store_final_db_sizer_inner->Add(where_to_save_database_input,1, wxCENTRE | wxALL);
            where_to_store_final_db_sizer_inner->Add(select_path_for_result_button);
        where_to_store_final_db_sizer->Add(where_to_store_final_db_sizer_inner,0,wxEXPAND | wxALL);
    only_sizer->Add(where_to_store_final_db_sizer,0, wxALL|wxEXPAND,5);
    only_sizer->AddSpacer(30);
    only_sizer->AddStretchSpacer ();


    //ok cancel buttons
        wxBoxSizer *buttons_sizer=new wxBoxSizer(wxHORIZONTAL);
        buttons_sizer->Add(cancel_button);
        buttons_sizer->AddSpacer(3);
        buttons_sizer->Add(ok_button);
    only_sizer->Add(buttons_sizer,0,wxCENTER,5);
    only_sizer->AddSpacer(5);
    main_panel->SetSizerAndFit(only_sizer);
	wxBoxSizer* frame_sizer=new wxBoxSizer(wxVERTICAL);
	frame_sizer->Add(main_panel, 1, wxALL|wxEXPAND);
	SetSizerAndFit(frame_sizer);
	only_sizer->RecalcSizes();
	frame_sizer->RecalcSizes();





    Bind(wxEVT_RADIOBUTTON, &BibTexGeneratorStandaloneWindow::OnRadioButtonChanged,this);
    select_path_for_result_button->Bind(wxEVT_BUTTON, &BibTexGeneratorStandaloneWindow::On_select_where_to_save_database_button_pressed, this);
    select_topic_button->Bind(wxEVT_BUTTON, &BibTexGeneratorStandaloneWindow::On_select_topic_button_pressed, this);
    cancel_button->Bind(wxEVT_BUTTON, &BibTexGeneratorStandaloneWindow::OnCancel, this);
    ok_button->Bind(wxEVT_BUTTON, &BibTexGeneratorStandaloneWindow::OnGenBibtexButtonPressed, this);


    }

void BibTexGeneratorStandaloneWindow::OnRadioButtonChanged(wxCommandEvent& event)
    {
    if(bibtex_gen_topic_radiobutton->GetValue())
        {
        input_for_topic->Enable();
        select_topic_button->Enable();
        topic_text->Enable();
        include_subtopics_checkbox->Enable();
        }
    else
        {
        input_for_topic->Disable();
        select_topic_button->Disable();
        topic_text->Disable();
        include_subtopics_checkbox->Disable();
        }
    }




void BibTexGeneratorStandaloneWindow::On_select_where_to_save_database_button_pressed(wxCommandEvent& event)
    {
    wxString home_dir = wxStandardPaths::Get().GetDocumentsDir();

	//Khz::PopupWins::MyFileDialog dlg(this, "Select where to save the generated bibtex database",
    //                 home_dir, "database.bib",
    //                 "bib files (*.bib)|*.bib", wxFC_SAVE, wxDefaultPosition);
    wxFileDialog dlg(this, "Select where to save the generated bibtex database",
                     home_dir, "database.bib",
                     "bib files (*.bib)|*.bib", wxFD_SAVE);


	if(dlg.ShowModal()==wxID_CANCEL) return;

    wxString path= dlg.GetPath();
    //std::cout << "\nfull path "<<  path.ToStdString().c_str();
    //std::cout << "\n filename " << dlg.file_ctrl->GetFilename();
    where_to_save_database_input->SetValue(path);
    }

void BibTexGeneratorStandaloneWindow::On_select_topic_button_pressed(wxCommandEvent &event)
    {
    wxSize temp_size =wxSize
            (
            Khz::Libs::MySizeFunctions::get_width_of_number_of_text_symbols(100, this),
            Khz::Libs::MySizeFunctions::get_height_of_number_of_text_rows(25, this)
            );

    Khz::PopupWins::MyTopicSelectorDialog dlg(this, wxID_ANY, "Select topic", wxDefaultPosition, temp_size);
    if(dlg.ShowModal()==wxID_CANCEL) return;
    wxString topic = dlg.library_tree->GetTopicString(dlg.library_tree->GetSelection());
    input_for_topic->SetValue(topic);
    }

void BibTexGeneratorStandaloneWindow::OnCancel(wxCommandEvent &event)
    {
    this->Close();
    }


void BibTexGeneratorStandaloneWindow::OnGenBibtexButtonPressed(wxCommandEvent &event)
    {
    wxString where_to_save_db= where_to_save_database_input->GetValue();

    //owerwrite warning
    if(wxFileExists(where_to_save_db) )
        {
        wxMessageDialog   msg(this,
                                    "The file \"" + where_to_save_db + "\" already exists. Owerwrite?",
                                    "Attention!", wxYES_NO|wxSTAY_ON_TOP) ;
        if(msg.ShowModal ()!=wxID_YES) return;
        }
    //cancels the  database generation if dir is not writable.
    else if (  !wxDirExists(wxFileName (where_to_save_db).GetPath())  or   !wxFileName::IsDirWritable(wxFileName (where_to_save_db).GetPath())   )
        {
                wxMessageDialog   err_msg(this,
                "Cannot write to the specified directory \"" + wxFileName (where_to_save_db).GetPath() + "\" where the bibtex database is supposed to be saved. Check that this directory exists and you have permission to write into it.",
                                    "Error", wxOK|wxCENTRE|wxICON_ERROR|wxSTAY_ON_TOP|wxCENTRE, wxDefaultPosition) ;
        err_msg.ShowModal ();
        return;
        }
    //cancels the  database generation if user wants database for topic, but topic is not specified.
    if(bibtex_gen_topic_radiobutton->GetValue() and (input_for_topic->GetValue()).Trim(true).Trim(false)=="")
        {
        wxMessageDialog   err_msg(this,
                "Please select topic",
                                    "Error", wxOK|wxCENTRE|wxICON_ERROR|wxSTAY_ON_TOP|wxCENTRE, wxDefaultPosition) ;
        err_msg.ShowModal ();
        return;
        }

    std::string where_statement;
    std::vector<std::string> placeholders_parameters;

    if(bibtex_gen_right_panel_radiobutton->GetValue())
        {
        wxWindow *temp;
        temp = this->GetParent();
        //the parent is the main window of the program (MyMainWindow).
        //we cannot get list of the books that are currently displayed on the right panel
        //from here. The list of the books could be retrieved only by the MyMainWindow class.
        //So we have to change the type of the pointer.

        //here we ask the main window of the program to return the WHERE statement.
        where_statement = ((Khz::MainWin::MyMainWindow *)   temp)->GetWhere();
        placeholders_parameters=((Khz::MainWin::MyMainWindow *)   temp)->GetPlaceHoldersParameters();
        temp=NULL;
        }
    else if( bibtex_gen_topic_radiobutton->GetValue() )
        {
        where_statement=this->PrepareWhereForTopic();
        }
    else if (bibtex_gen_all_radiobutton->GetValue() )
        {
        where_statement="";
        }
    else
        {
        std::cout << "\n bad radiobutton position in BibTexGeneratorStandaloneWindow.cpp";
        abort();
        }

    this->GenerateBibtex(where_statement, placeholders_parameters, where_to_save_database_input->GetValue());
    this->Close();
    //event_to_propagate.SetPath(where_to_save_database_input->GetValue());
    //event.SetEventObject(this);
    //this->GetParent()->GetEventHandler()->QueueEvent(event_to_propagate.Clone());
    //this->Close();
    }


std::string BibTexGeneratorStandaloneWindow::PrepareWhereForTopic()
    {
    sqlite3 *db;
    try
        {
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                            //let us look into config file and connect to the database
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        wxString ini_filename = ConfigManager::GetPathToConfigFile();
        wxFileConfig *config =new wxFileConfig( "", "", ini_filename);
        wxCharBuffer temp_char_buffer=Khz::Libs::DB::clear_path(config->Read("PATHS/path_to_database","")).ToUTF8();
        delete config;
        sqlite3_open( temp_char_buffer, &db);
        // std::cout << "\n path to db " << config->Read("PATHS/path_to_database","") << "\n";
        sqlite3_exec(db,"PRAGMA encoding = \"UTF-8\"" , 0, 0, 0);
        sqlite3_exec(db, "PRAGMA case_sensitive_like=OFF", 0, 0, 0);
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                            //connected to the database
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        sqlite3_stmt *stmt = NULL;
        int retval=0;
        if(retval) return "";// to remove compiller warning

        std::string query;
        std::string topic_in_input=input_for_topic->GetValue().ToUTF8().data();
        if(include_subtopics_checkbox->GetValue())
            {
            query= "SELECT ID from topics WHERE Topic LIKE ?;";
            retval = sqlite3_prepare_v2(db, query.c_str(), -1, &stmt, 0);
            sqlite3_bind_text(stmt,  1, (topic_in_input+"%").c_str(), -1, SQLITE_TRANSIENT);
            }
        else
            {
            query ="SELECT ID from topics WHERE Topic=?;";
            retval = sqlite3_prepare_v2(db, query.c_str(), -1, &stmt, 0);
            sqlite3_bind_text(stmt,  1, (topic_in_input).c_str(), -1, SQLITE_TRANSIENT);
            }
        sqlite3_step( stmt ); //executing the statement
        Khz::Libs::DB::mapDB result = Khz::Libs::DB::dbcontent(stmt) ;
        sqlite3_finalize(stmt);
        sqlite3_close(db);

        long long result_size= result.size();
        if(result_size==0)
            {
            return "";
            }
        else if(result_size==1)
            {
            return "ID_of_Topic="+result[0]["ID"];
            }
        else
            {
            std::string temp_string;
            long long counter =0;
            for(long long i=0;i<result_size;i++)
                {
                if(counter==result_size-1)
                    {
                    temp_string=temp_string + "ID_of_Topic="+result[i]["ID"];
                    }
                else
                    {
                    temp_string=temp_string + "ID_of_Topic="+result[i]["ID"] + " OR ";
                    }
                counter++;
                }
            return "("+temp_string+")";
            }

        }
     catch(...)
        {
        sqlite3_close(db);
        return "";
        }
    }





void BibTexGeneratorStandaloneWindow::GenerateBibtex(std::string &where_statement, std::vector<std::string> &placeholder_parameters, wxString where_to_save_bib)
    {
    //open config//////////////////////////////////////////////////
    wxString ini_filename = ConfigManager::GetPathToConfigFile();
    wxFileConfig *config =new wxFileConfig( "", "", ini_filename);
    // ok, opened/////////////////////////////////////////////////////////////



    //we have to connect to the main kolkhoznik database.
    wxCharBuffer temp_char_buffer=Khz::Libs::DB::clear_path(config->Read("PATHS/path_to_database","")).ToUTF8();
    sqlite3 *db;
    sqlite3_open( temp_char_buffer, &db);
    sqlite3_exec(db,"PRAGMA encoding = \"UTF-8\"" , 0, 0, 0);
    sqlite3_exec(db, "PRAGMA case_sensitive_like=OFF", 0, 0, 0);
    //ok, now we are connected to the database.




    //how many books should we get from db by one query? Let's use the cache size.
    wxString max_cache_size_str= config->Read("ADVANCED/max_size_of_cache", "4000");
    if(max_cache_size_str=="") max_cache_size_str="4000";
    int max_size_of_cache=wxAtoi(max_cache_size_str);
    delete config;




    //now we are looking into the main kolkhoznik database
    Khz::Libs::DB::get_books_from_db_by_query
        database_asker(db, "main", where_statement, max_size_of_cache, placeholder_parameters);

    std::string NEWLINE_CHAR = wxString(wxTextFile::GetEOL()).ToStdString();  // \r\n or \n for windows and linux respectively
    //Now everything is ready, finally we can generate the database


    // now we can create the bib file
    std::ofstream bib_file;
    bib_file.open(where_to_save_bib.ToStdString(), std::ios::out | std::ios::trunc);
    if(!bib_file)
        {
         wxString message= "Cannot open the bib file. The bibtex database generation will be terminated";

            wxMessageBox(message, wxT("Error"), wxOK | wxICON_ERROR);
            return;
        }
    // ok, created//////////////////////////////////



    //put data of the database generation to the bib file
    wxDateTime now = wxDateTime::Now();
    bib_file << "%This is a very cool bib file generated on " << now.Format().ToStdString() << NEWLINE_CHAR;




    // progress bar
    wxGenericProgressDialog progress("Bibtex generation progress", "The bibtex database is being generated",
                                                      100, this, wxPD_CAN_ABORT);
    this->Update();
    progress.Update(0);


    //the next 3 temp_counter's are used for progressbar update.
    long long temp_counter=0;


    //////////////////////////////////////////////////////////////////////////////////////
    // Now we generating the bibtex database
    //////////////////////////////////////////////////////////////////////////////////////
    while(database_asker.Step())
        {
        //std::cout << "\npisdec\n";
        for(unsigned long i=0;i<database_asker.current_result.size();i++)
            {
            temp_counter++;
            std::string Author=database_asker.current_result[i]["Author"];
            std::string Title=database_asker.current_result[i]["Title"];
            std::string Publisher=database_asker.current_result[i]["Publisher"];
            std::string Year=database_asker.current_result[i]["Year"];
            std::string Edition=database_asker.current_result[i]["Edition"];
            std::string Additional_key=database_asker.current_result[i]["ID"];

            std::string bib_entry= Khz::BibTex::GenBib::GenBibtexEntryFromFields(Author, Title,
                                        Publisher, Year, Edition, Additional_key);
            Khz::Libs::Mstr::replaceAll(bib_entry, "\n", NEWLINE_CHAR);
            bib_file<< bib_entry << NEWLINE_CHAR;

            //update progress bar
            //if( database_asker.GetTotalLines() and  1.0*(temp_counter2++)/database_asker.GetTotalLines()*100>=1.0  )
            //    {
            //    temp_counter2 = 0;
            //
                if(!progress.Update(100.0*temp_counter/database_asker.GetTotalLines()))
                    { //cancel button was pressed
                    sqlite3_close(db);
                   // progress->Destroy();
                    return;
                    };
            //    }
            }
        }
        //std::cout << "\ntotal steps "<< database_asker.GetTotalSteps();
        //std::cout << "\nstep " << database_asker.GetCurrentStep();
    progress.Update(100);
    bib_file.close();
    sqlite3_close(db);
    }



}}// end of namespace
