/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "CfgTabFullTextSearchGeneral.h"
#include "Custom_IDs.h"
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <iostream>


namespace Khz{namespace CfgWin{


CfgTabFullTextSearchGeneral::CfgTabFullTextSearchGeneral(wxWindow* parent, wxString path_to_config)
     : Configure_gui_tabs_parent(parent, path_to_config)
    {

    /////////////////////////////////////////////////////////////////////////////
    //              left /right border
    /////////////////////////////////////////////////////////////////////////////////
    this->left_right_border_input=new wxSpinCtrl(this, wxID_ANY);
    left_right_border_input->SetRange(0,1000);
    this->left_right_border=wxAtoi(config->Read("FULL_TEXT_SEARCH/left_right_border" , "30"));
    left_right_border_input->SetValue(left_right_border);





    ///////////////////////////////////////////////////////////////////////////////
    //             icons
    ///////////////////////////////////////////////////////////////////////////////
    icons_size_input = new wxChoice( this, wxID_ANY);
    wxString icons_size_string =config->Read("FULL_TEXT_SEARCH/icons_size","");

     if(icons_size_string!="")
        {
        icons_size=wxAtoi(icons_size_string);
        }
    else
        {
        icons_size=16;
        }
      icons_sizes_vector.push_back(std::make_pair(-1, wxString("No icons")));
      icons_sizes_vector.push_back(std::make_pair(16, wxString("16")));
      icons_sizes_vector.push_back(std::make_pair(20, wxString("20")));
      icons_sizes_vector.push_back(std::make_pair(22, wxString("22")));
      icons_sizes_vector.push_back(std::make_pair(32, wxString("32")));
      icons_sizes_vector.push_back(std::make_pair(48, wxString("48")));

    for(unsigned int i=0;i<icons_sizes_vector.size();i++)
        {
        icons_size_input->Append(icons_sizes_vector[i].second);
        if(icons_sizes_vector[i].first==icons_size)
            {
            icons_size_input->SetSelection (i);
            }
        }



    ////////////////////////////////////////////////////////////////////////////////
    //      scrollrate
    ////////////////////////////////////////////////////////////////////////

    scrollrate_input=new wxSpinCtrl(this, wxID_ANY);
    scrollrate_input->SetRange(1, 100);
    scrollrate=wxAtoi(config->Read("FULL_TEXT_SEARCH/scrollrate","10"));
    scrollrate_input->SetValue(scrollrate);







    ////////////////////////////////////////////////////////////////////////////////
    //            samples number
    ////////////////////////////////////////////////////////////////////////////////

    samples_number_input=new wxSpinCtrl(this, wxID_ANY);
    samples_number_input->SetRange(0,10);
    samples_number=wxAtoi(config->Read("FULL_TEXT_SEARCH/samples_number","3"));
    samples_number_input->SetValue(samples_number);




    ///////////////////////////////////////////////////////////////////////////
    //           samples size
    ///////////////////////////////////////////////////////////////////////////
    samples_size_input=new wxSpinCtrl(this, wxID_ANY);
    samples_size_input->SetRange(1, 100);
    samples_size=wxAtoi(config->Read("FULL_TEXT_SEARCH/sample_size","17"));
    samples_size_input->SetValue(samples_size);


    //////////////////////////////////////////////////////////////////////////////
    //         show menubar checkbox
    ////////////////////////////////////////////////////////////////////////////
    show_menubar_checkbox=new wxCheckBox(this, wxID_ANY, "show menubar");
    wxString show_menubar=config->Read("FULL_TEXT_SEARCH/show_menubar","true");
    if(show_menubar=="true")
        {show_menubar_checkbox->SetValue(true); this->show_menubar=true;}
        else
        {show_menubar_checkbox->SetValue(false); this->show_menubar=false;}


    // ######################cancel, apply, ok buttons"###########################
    wxButton *cancel_button = new wxButton(this,wxID_ANY, "Cancel");
    apply_button = new wxButton(this, Khz::my_wx_id__CONFIGURE_GUI_APPLY_CHANGES, "Apply");
    apply_button->Disable();
    wxButton *ok_button = new wxButton(this, Khz::my_wx_id__CONFIGURE_GUI_OK_CHANGES, "Ok");
    //#################################################################################


    int left_right_border=5;
    wxBoxSizer *main_sizer=new wxBoxSizer(wxVERTICAL);
        wxBoxSizer *border_icons_sizer=new wxBoxSizer(wxHORIZONTAL);
            wxBoxSizer *border_sizer=new wxBoxSizer(wxVERTICAL);
            border_sizer->Add(new wxStaticText(this, wxID_ANY, "left/right border"));
            border_sizer->Add(left_right_border_input);
        border_icons_sizer->Add(border_sizer, 0, wxALL, 5);
            wxBoxSizer *icons_sizer=new wxBoxSizer(wxVERTICAL);
            icons_sizer->Add(new wxStaticText(this, wxID_ANY, "icons size"));
            icons_sizer->Add(icons_size_input);
        border_icons_sizer->Add(icons_sizer, 0, wxALL, 5);
            wxBoxSizer *scrollrate_sizer = new wxBoxSizer (wxVERTICAL);
            scrollrate_sizer->Add(new wxStaticText(this, wxID_ANY, "scrollrate"));
            scrollrate_sizer->Add(scrollrate_input);
        border_icons_sizer->Add(scrollrate_sizer, 0, wxALL, 5);
    main_sizer->Add(border_icons_sizer);
        wxBoxSizer *samples_sizer=new wxBoxSizer(wxHORIZONTAL);
            wxBoxSizer *samples_number_sizer=new wxBoxSizer(wxVERTICAL);
            samples_number_sizer->Add(new wxStaticText(this, wxID_ANY, "samples number"));
            samples_number_sizer->Add(samples_number_input);
        samples_sizer->Add(samples_number_sizer, 0, wxALL, 5);
            wxBoxSizer *samples_size_sizer=new wxBoxSizer(wxVERTICAL);
            samples_size_sizer->Add(new wxStaticText(this, wxID_ANY, "sample size"));
            samples_size_sizer->Add(samples_size_input);
        samples_sizer->Add(samples_size_sizer, 0, wxALL, 5);
            wxBoxSizer *show_menubar_sizer=new wxBoxSizer(wxVERTICAL);
            show_menubar_sizer->Add(new wxStaticText(this, wxID_ANY, " "));
            show_menubar_sizer->Add(show_menubar_checkbox);
        samples_sizer->Add(show_menubar_sizer, 0, wxALL, 5);

    main_sizer->Add(samples_sizer);


        wxBoxSizer *three_last_buttons = new wxBoxSizer(wxHORIZONTAL);

        //#################### buttons ##########################################################
        three_last_buttons->AddStretchSpacer ();
        three_last_buttons->Add(cancel_button);
        three_last_buttons->AddSpacer(10);
        three_last_buttons->Add(apply_button);
        three_last_buttons->AddSpacer(10);
        three_last_buttons->Add(ok_button);
        three_last_buttons->AddSpacer(left_right_border);
        wxSizerFlags flag_to_fit_two_last_buttons(0);
        flag_to_fit_two_last_buttons.Expand();
        flag_to_fit_two_last_buttons.Border(wxBOTTOM, 10);
        //###############################################################################################################
    main_sizer->AddStretchSpacer ();
    main_sizer->Add(three_last_buttons, flag_to_fit_two_last_buttons);
    SetSizerAndFit(main_sizer);


     apply_button->Bind(wxEVT_BUTTON, &CfgTabFullTextSearchGeneral::on_apply_pressed, this);
    ok_button->Bind(wxEVT_BUTTON, &CfgTabFullTextSearchGeneral::on_ok_pressed, this);
    cancel_button->Bind(wxEVT_BUTTON, &CfgTabFullTextSearchGeneral::on_cancel_pressed, this);


    Bind(wxEVT_SPINCTRL, &CfgTabFullTextSearchGeneral::on_some_spinctrl_or_textctrl_changed, this);

    Bind(wxEVT_TEXT, &CfgTabFullTextSearchGeneral::on_some_spinctrl_or_textctrl_changed2, this);
    icons_size_input->Bind(wxEVT_CHOICE, &CfgTabFullTextSearchGeneral::on_icons_size_input_changed, this);

    Bind(wxEVT_SPINCTRL, &CfgTabFullTextSearchGeneral::on_some_spinctrl_or_textctrl_changed, this);

    Bind(wxEVT_TEXT, &CfgTabFullTextSearchGeneral::on_some_spinctrl_or_textctrl_changed2, this);
    show_menubar_checkbox->Bind(wxEVT_CHECKBOX, &CfgTabFullTextSearchGeneral::on_show_menubar_checkbox_clicked, this);
    }

void CfgTabFullTextSearchGeneral::write_changes_to_config()
    {
    this->ReconfigureType=Khz::my_wx_id__FULL_TEXT_SEARCH_REDRAW_HTML_EVENT;
    delete config;
    config =new wxFileConfig( "", "", config_file);


    config->Write("FULL_TEXT_SEARCH/left_right_border" , left_right_border);
    config->Write( wxT("FULL_TEXT_SEARCH/icons_size"), icons_size );


    config->Write("FULL_TEXT_SEARCH/scrollrate",scrollrate);

    config->Write("FULL_TEXT_SEARCH/samples_number",samples_number);

    config->Write("FULL_TEXT_SEARCH/sample_size",samples_size);


    show_menubar==true ? config->Write("FULL_TEXT_SEARCH/show_menubar","true")
                            :config->Write("FULL_TEXT_SEARCH/show_menubar","false");


    config->Flush();


    delete config;
    config =new wxFileConfig( "", "", config_file);
    apply_button->Disable();
    this->IsModified=false;
    }

void CfgTabFullTextSearchGeneral::restore_values()
    {
    this->left_right_border=wxAtoi(config->Read("FULL_TEXT_SEARCH/left_right_border" , "30"));
    left_right_border_input->SetValue(left_right_border);







     wxString icons_size_string=config->Read( wxT("FULL_TEXT_SEARCH/icons_size"), "16" );
    if(icons_size_string!="")
        {
        icons_size=wxAtoi(icons_size_string);
        }
    else
        {
        icons_size=16;
        }
    for(unsigned int i=0;i<icons_sizes_vector.size();i++)
        {
        if(icons_sizes_vector[i].first==icons_size)
            {
            icons_size_input->SetSelection (i);
            }
        }


    scrollrate=wxAtoi(config->Read("FULL_TEXT_SEARCH/scrollrate","10"));
    scrollrate_input->SetValue(scrollrate);



    samples_number=wxAtoi(config->Read("FULL_TEXT_SEARCH/samples_number","3"));
    samples_number_input->SetValue(samples_number);

    samples_size=wxAtoi(config->Read("FULL_TEXT_SEARCH/sample_size","17"));
    samples_size_input->SetValue(samples_size);



    wxString show_menubar=config->Read("FULL_TEXT_SEARCH/show_menubar","true");
    if(show_menubar=="true")
        {show_menubar_checkbox->SetValue(true); this->show_menubar=true;}
        else
        {show_menubar_checkbox->SetValue(false); this->show_menubar=false;}


    apply_button->Disable();
    IsModified=false;
    }

void CfgTabFullTextSearchGeneral::on_apply_pressed(wxCommandEvent &event)
    {
    this->write_changes_to_config();
    this->send_reconfigure_panels_event();
    apply_button->Disable();
    IsModified=false;
    }

void CfgTabFullTextSearchGeneral::on_ok_pressed(wxCommandEvent &event)
    {
        if(IsModified)
        {
        this->write_changes_to_config();
        this->send_reconfigure_panels_event();
        }
    //std::cout << "\nclosing config\n";
    this->send_close_event_manually();
    }

void CfgTabFullTextSearchGeneral::on_cancel_pressed(wxCommandEvent &event)
    {
    this->send_close_event_manually(); //close the configuration window
    }


void CfgTabFullTextSearchGeneral::read_spinctrl_and_textctrl_values()
    {
    left_right_border=left_right_border_input->GetValue();
    scrollrate=scrollrate_input->GetValue();

    samples_number=samples_number_input->GetValue();
    samples_size=samples_size_input->GetValue();
    }


void CfgTabFullTextSearchGeneral::on_some_spinctrl_or_textctrl_changed(wxSpinEvent& event)
    {
    read_spinctrl_and_textctrl_values();

    IsModified=true;
    apply_button->Enable();
    }

void CfgTabFullTextSearchGeneral::on_some_spinctrl_or_textctrl_changed2(wxCommandEvent& event)
    {
    read_spinctrl_and_textctrl_values();

    IsModified=true;
    apply_button->Enable();
    }


void CfgTabFullTextSearchGeneral::on_icons_size_input_changed(wxCommandEvent& event)
    {
    int selected_item=icons_size_input->GetSelection();
    if(selected_item!=wxNOT_FOUND)
        {
        icons_size=icons_sizes_vector[selected_item].first;
        this->apply_button->Enable();
        this->IsModified=true;
        }
    else
        {
        std::cout << "\n something terrible happen 2 in CfgTabIconsChooser.cpp, aborted\n";
        abort();
        }
    }

void CfgTabFullTextSearchGeneral::on_show_menubar_checkbox_clicked(wxCommandEvent &event)
    {
    bool is_checked=show_menubar_checkbox->GetValue();
    if (is_checked) show_menubar=true; else show_menubar=false;
    IsModified=true;
    apply_button->Enable();
    }
}}// namespaces
