/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



#include <wx/window.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/fileconf.h>
#include <wx/dirdlg.h>
#include <wx/filedlg.h>
#include "Custom_IDs.h"
#include "Configure_tabs_parent.h"
#include "CfgTabPathsChooser.h"


namespace Khz{namespace CfgWin{


CfgTabPathsChooser::CfgTabPathsChooser(wxWindow* parent,  wxString path_to_config)
    : Configure_gui_tabs_parent(parent, path_to_config)
    {
    is_path_entry_modified=false;
    is_database_entry_modified=false;
    is_xapian_entry_modified=false;
   // #########PATH TO LIBRARY########################################
    library_dir_input=new wxTextCtrl(this,wxID_ANY,wxEmptyString, wxDefaultPosition
                                  //, wxSize(-1, 28)
                                  );



    library_dir_input->SetValue (config->Read("PATHS/path_to_dir_with_books",""));
    wxButton *choose_path_to_library_button = new wxButton(this,wxID_ANY, "Choose");
    // ######################################################################################




    // ####### PATH TO DATABASE#################################################
    where_to_store_database_input = new wxTextCtrl(this,wxID_ANY, "" , wxDefaultPosition
                                 // , wxSize(-1, 28)
                                  );
    where_to_store_database_input->SetValue(config->Read("PATHS/path_to_database",""));
    wxButton *choose_path_to_database_button = new wxButton(this,wxID_ANY, "Choose");
    //######################################################################


    // ####################   Path to xapian     ################################
    xapian_dir_input=new wxTextCtrl(this, wxID_ANY);
    xapian_dir_input->SetValue(config->Read("FULL_TEXT_SEARCH/database_path", ""));
    wxButton *choose_path_to_xapian_button=new wxButton(this, wxID_ANY, "Choose");
    // ############################################################################




    // ######################cancel, apply, ok buttons"###########################
    wxButton *cancel_button = new wxButton(this,wxID_ANY, "Cancel");
    apply_button = new wxButton(this,Khz::my_wx_id__CONFIGURE_GUI_APPLY_CHANGES, "Apply");
    apply_button->Disable();
    wxButton *ok_button = new wxButton(this,Khz::my_wx_id__CONFIGURE_GUI_OK_CHANGES, "Ok");
    //#############################################################################################


    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!   SIZING !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    int left_right_border=5;
    only_sizer = new wxBoxSizer( wxVERTICAL );
    only_sizer->AddSpacer(20);
        //##############choose path to library sizers##################################################################
        wxBoxSizer *input_dir_text= new wxBoxSizer( wxHORIZONTAL );                                                               //
        input_dir_text->AddSpacer(left_right_border);                                                                 //
        input_dir_text->Add(new wxStaticText( this, wxID_ANY, wxT("Kolkhoz library directory")), 0,  wxEXPAND);                                              //
        input_dir_text->AddSpacer(left_right_border);                                                                 //
    only_sizer->Add(input_dir_text, 0, wxEXPAND|wxALL);   //text "choose library path"                                                  //                                                                                                           //

                                                                                                                  //
        wxBoxSizer *input_dir_with_library_sizer = new wxBoxSizer( wxHORIZONTAL );                                    //
        input_dir_with_library_sizer->AddSpacer(left_right_border);                                                   //
        input_dir_with_library_sizer->Add(library_dir_input,1, wxEXPAND|wxALL);  //input for library path                 //
        input_dir_with_library_sizer->AddSpacer(5);
        input_dir_with_library_sizer->Add(choose_path_to_library_button);  //button to choose dir with library        //
        input_dir_with_library_sizer->AddSpacer(left_right_border);
    only_sizer->Add(input_dir_with_library_sizer, 0, wxEXPAND|wxALL);
    only_sizer->AddSpacer(20);                                                           //
    //##############finished choose path for library  #############################################################


        // ##############    Path to xapian input ##############################################################
        wxBoxSizer *xapian_text_sizer= new wxBoxSizer( wxHORIZONTAL );                                                               //
        xapian_text_sizer->AddSpacer(left_right_border);                                                                 //
        xapian_text_sizer->Add(new wxStaticText( this, wxID_ANY, wxT("Path to the full text search database")), 0, wxALL|wxEXPAND);                                              //
        xapian_text_sizer->AddSpacer(left_right_border);                                                                 //
    only_sizer->Add(xapian_text_sizer, 0, wxEXPAND|wxALL);

        wxBoxSizer *input_xapian_sizer = new wxBoxSizer( wxHORIZONTAL );                                    //
        input_xapian_sizer->AddSpacer(left_right_border);                                                   //
        input_xapian_sizer->Add(xapian_dir_input,1, wxALL);  //input for library path                 //
        input_xapian_sizer->AddSpacer(5);
        input_xapian_sizer->Add(choose_path_to_xapian_button);  //button to choose dir with library        //
        input_xapian_sizer->AddSpacer(left_right_border);
    only_sizer->Add(input_xapian_sizer, 0, wxEXPAND|wxALL);
    only_sizer->AddSpacer(20);                                                         //
    // ################## finished path to xapain ####################################################

        //##############choose path to database sizers#############################################################
        wxBoxSizer *input_database_text= new wxBoxSizer( wxHORIZONTAL );                                               //
        input_database_text->AddSpacer(left_right_border);                                                             //
        input_database_text->Add(new wxStaticText( this, wxID_ANY, wxT("Database path")), 0, wxEXPAND);                                         //
        input_database_text->AddSpacer(left_right_border);                                                             //
    only_sizer->Add(input_database_text, 0, wxEXPAND|wxALL);                                   //
    //flags_choose_path_to_database_sizer_text.Border(wxBOTTOM, 10);                                                    //
                                                                                                                   //
                                                                                                                   //
        wxBoxSizer *input_database_path_sizer = new wxBoxSizer( wxHORIZONTAL );                                        //
        input_database_path_sizer->AddSpacer(left_right_border);                                                       //
        input_database_path_sizer->Add(where_to_store_database_input,1, wxALL);  //input for library path         //
        input_database_path_sizer->AddSpacer(5);
        input_database_path_sizer->Add(choose_path_to_database_button);  //button to choose dir with library           //
        input_database_path_sizer->AddSpacer(left_right_border);
     only_sizer->Add(input_database_path_sizer, 0, wxEXPAND|wxALL);                                                                //
    //##############finished choose path for library  #############################################################


        //#################### buttons ##########################################################
        wxBoxSizer *three_last_buttons = new wxBoxSizer(wxHORIZONTAL);
        three_last_buttons->AddStretchSpacer ();
        three_last_buttons->Add(cancel_button);
        three_last_buttons->AddSpacer(10);
        three_last_buttons->Add(apply_button);
        three_last_buttons->AddSpacer(10);
        three_last_buttons->Add(ok_button);
        three_last_buttons->AddSpacer(left_right_border);
        wxSizerFlags flag_to_fit_two_last_buttons(0);
        flag_to_fit_two_last_buttons.Expand();
        flag_to_fit_two_last_buttons.Border(wxBOTTOM, 10);
        //###############################################################################################################

    only_sizer->AddStretchSpacer ();
    only_sizer->Add(three_last_buttons, flag_to_fit_two_last_buttons);

    SetSizerAndFit(only_sizer);


    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!! SIZING FINISHED !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    choose_path_to_library_button->Bind(wxEVT_BUTTON, &CfgTabPathsChooser::DoKolhozPathChoose, this);
    choose_path_to_database_button->Bind(wxEVT_BUTTON, &CfgTabPathsChooser::DoKolhozDatabasePathChoose, this);
    choose_path_to_xapian_button->Bind(wxEVT_BUTTON, &CfgTabPathsChooser::DoXapianDatabasePathChoose, this);

    apply_button->Bind(wxEVT_BUTTON, &CfgTabPathsChooser::on_apply_pressed, this);
    ok_button->Bind(wxEVT_BUTTON, &CfgTabPathsChooser::on_ok_pressed, this);
    cancel_button->Bind(wxEVT_BUTTON, &CfgTabPathsChooser::on_cancel_pressed, this);


    library_dir_input->Bind(wxEVT_TEXT, &CfgTabPathsChooser::OnKolkhozDirInputChanged, this);
    where_to_store_database_input->Bind(wxEVT_TEXT, &CfgTabPathsChooser::OnDatabasePathChanged, this);
    xapian_dir_input->Bind(wxEVT_TEXT, &CfgTabPathsChooser::OnXapianPathChanged, this);

    }

void CfgTabPathsChooser::OnKolkhozDirInputChanged(wxCommandEvent& event)
    {
    is_path_entry_modified=true;
    apply_button->Enable();
    IsModified=true;
    }

void CfgTabPathsChooser::OnXapianPathChanged(wxCommandEvent& event)
    {
    is_xapian_entry_modified=true;
    apply_button->Enable();
    IsModified=true;
    }


void CfgTabPathsChooser::OnDatabasePathChanged(wxCommandEvent& event)
    {
    is_database_entry_modified=true;
    apply_button->Enable();
    IsModified=true;
    }


void CfgTabPathsChooser::DoKolhozPathChoose(wxCommandEvent& event)
{
    // pass some initial dir to wxDirDialog
    wxString dirHome;
    wxGetHomeDir(&dirHome);

    wxDirDialog dialog(this, wxT("Select folder with books"), dirHome, wxDD_DEFAULT_STYLE && wxDD_DIR_MUST_EXIST);

    if (dialog.ShowModal() == wxID_OK)
    {
        library_dir_input->SetValue (dialog.GetPath());
        apply_button->Enable();
        is_path_entry_modified=true;
        IsModified=true;
    }
}

void CfgTabPathsChooser::DoKolhozDatabasePathChoose(wxCommandEvent &event)
{
    wxString dirHome;
    wxGetHomeDir(&dirHome);

    wxFileDialog dialog(this, wxT("Choose existing database"), dirHome);

    if (dialog.ShowModal() == wxID_OK)
    {
        where_to_store_database_input->SetValue (dialog.GetPath());
        is_database_entry_modified=true;
        apply_button->Enable();
        IsModified=true;
    }
}



void CfgTabPathsChooser::DoXapianDatabasePathChoose(wxCommandEvent &event)
{
    // pass some initial dir to wxDirDialog
    wxString dirHome;
    wxGetHomeDir(&dirHome);

    wxDirDialog dialog(this, wxT("Choose existing xapian database"), dirHome, wxDD_DEFAULT_STYLE && wxDD_DIR_MUST_EXIST);

    if (dialog.ShowModal() == wxID_OK)
    {
        xapian_dir_input->SetValue (dialog.GetPath());
        apply_button->Enable();
        is_xapian_entry_modified=true;
        IsModified=true;
    }
}



void CfgTabPathsChooser::write_changes_to_config()
    {

    if(is_database_entry_modified and is_xapian_entry_modified)
        {
        this->ReconfigureType=Khz::my_wx_id__RECONFIGURE_EVERYTHING;
        }
    else if (is_database_entry_modified)
        {
        this->ReconfigureType=Khz::my_wx_id__RECONFIGURE_MAINWIN;
        }


    else if( is_xapian_entry_modified and is_path_entry_modified)
        {
        this->ReconfigureType=Khz::my_wx_id__RECONFIGURE_XAPIAN_AND_PATH_TO_DIR_WITH_BOOKS;
        }
    else if (is_xapian_entry_modified)
        {
        this->ReconfigureType=Khz::my_wx_id__RECONFIGURE_XAPIAN;
        }


    else
        {
        this->ReconfigureType=Khz::my_wx_id__RECONFIGURE_JUST_READ_CONFIG_AGAIN;
        }


    wxString new_database_path=where_to_store_database_input->GetValue();
    wxString new_library_path=library_dir_input->GetValue();
    wxString new_xapian_path=xapian_dir_input->GetValue();
    delete config;
    config =new wxFileConfig( "", "", config_file);
    config->Write("PATHS/path_to_dir_with_books", new_library_path );
    config->Write("PATHS/path_to_database", new_database_path );
    config->Write("FULL_TEXT_SEARCH/database_path", new_xapian_path);
    config->Flush();


    delete config;
    config =new wxFileConfig( "", "", config_file);
    apply_button->Disable();
    this->IsModified=false;
    is_path_entry_modified=false;
    is_database_entry_modified=false;
    is_xapian_entry_modified=false;
    }

void CfgTabPathsChooser::on_apply_pressed(wxCommandEvent& event)
    {
    this->write_changes_to_config();
    this->send_reconfigure_panels_event();
    apply_button->Disable();
    IsModified=false;
    is_path_entry_modified=false;
    is_database_entry_modified=false;
    is_xapian_entry_modified=true;
    }

void CfgTabPathsChooser::on_ok_pressed(wxCommandEvent& event)
    {
    if(IsModified)
        {
        this->write_changes_to_config();
        this->send_reconfigure_panels_event();
        }
    //std::cout << "\nclosing config\n";
    this->send_close_event_manually();
    }
void CfgTabPathsChooser::on_cancel_pressed(wxCommandEvent& event)
    {
    this->send_close_event_manually();
    }

void CfgTabPathsChooser::restore_values()
    {
    library_dir_input->SetValue (config->Read("PATHS/path_to_dir_with_books",""));
    where_to_store_database_input->SetValue(config->Read("PATHS/path_to_database",""));
    apply_button->Disable();
    IsModified=false;
    is_path_entry_modified=false;
    is_database_entry_modified=false;
    is_xapian_entry_modified=false;
    }


}}// end of namespaces
