/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "ConfigureGui.h"
#include "Configure_tabs_parent.h"
#include "Custom_IDs.h"
#include "MySizeFunctions.h"


namespace Khz{namespace CfgWin{


ConfigureGui::ConfigureGui(wxWindow *parent, wxString path_to_config)
    :wxFrame(parent, wxID_ANY, "Configure Kolkhoznik",wxDefaultPosition  	//wxSize(800, 600)
    )
    {
    #include "CoolIcon.xpm"
	#include "icon42.xpm"
    SetIcon(wxIcon(CoolIcon_xpm));

    //wxPanel *main_panel =new wxPanel(this, wxID_ANY);
    images_list = new wxImageList(42, 42, true);
     images_list->Add(wxIcon(icon42_xpm));

    main_treebook= new wxListbook(this, wxID_ANY);
    main_treebook->AssignImageList(images_list);

    ///////////// Creating subwindows////////////////////////////////////////////////
    fts_config_window=
            new ConfigureGuiSubwindow_full_text_search_window(main_treebook, path_to_config);

    main_config_window=
            new ConfigureGuiSubwindow_main_window(main_treebook, path_to_config);


    general_config_window=
            new ConfigureGuiSubwindow_general(main_treebook, path_to_config);

    fts_indexer_params=
            new ConfigureGuiSubwindow_full_text_search_indexer_params(main_treebook, path_to_config);
    ////////////////////////////////////////////////////////////////////////////////

    ////////  prepare string "Full text search window"////////////
    ////////this string is too long so we split it by symbol "\n";
    //////  code below creates two lines string, the last line is CENTERED
    //////// like this:    Full text search
    ////////                   window
    wxString top_string="Full text search";
    int top_width= Khz::Libs::MySizeFunctions::get_width_of_string(top_string, this);
    wxString bottom_string ="window";
    for(;;)
        {
        if(Khz::Libs::MySizeFunctions::get_width_of_string(bottom_string, this)>=top_width) break;
        bottom_string=" " + bottom_string+ " ";
        }
    wxString fts_string= top_string + "\n" +bottom_string;
    ////////////////////////////////////////////////////////////////////////////////





     ////////  prepare string "Full text search config params"////////////
    ////////this string is too long so we split it by symbol "\n";
    //////  code below creates two lines string, the last line is CENTERED
    //////// like this:    Full text search
    ////////                indexer params
    top_string="Full text search";
    top_width= Khz::Libs::MySizeFunctions::get_width_of_string(top_string, this);
    bottom_string ="indexer params";
    for(;;)
        {
        if(Khz::Libs::MySizeFunctions::get_width_of_string(bottom_string, this)>=top_width) break;
        bottom_string=" " + bottom_string+ " ";
        }
    wxString fts_string_params= top_string + "\n" +bottom_string;
    ////////////////////////////////////////////////////////////////////////////////




    main_treebook->AddPage(general_config_window, "General",false,0 );
    main_treebook->AddPage(main_config_window, "Main window",false,0 );
    main_treebook->AddPage(fts_config_window, fts_string, false, 0);
    main_treebook->AddPage(fts_indexer_params, fts_string_params, false, 0);

    Bind(wxEVT_BUTTON, &ConfigureGui::on_close_event, this,Khz::my_wx_id__MANUAL_CLOSE_EVENT);
    Bind(wxEVT_LISTBOOK_PAGE_CHANGING, &ConfigureGui::OnTabChanging, this);

    //wxBoxSizer *panel_sizer=new wxBoxSizer(wxVERTICAL);
    //panel_sizer->Add(main_treebook, 1, wxEXPAND|wxALL, 5);
    //main_panel->SetSizerAndFit(panel_sizer);

    wxBoxSizer *main_sizer = new wxBoxSizer(wxVERTICAL);
    main_sizer->Add(main_treebook,1, wxALL|wxEXPAND, 5);
    SetSizer(main_sizer);

    //this->RefitManually();
    }

void ConfigureGui::on_close_event(wxCommandEvent &event)
    {
    this->Close();
    }

void ConfigureGui::OnTabChanging(wxBookCtrlEvent& event)
    {
    int pade_id=event.GetOldSelection();
    if(pade_id== wxNOT_FOUND) return;
    ConfigureGuiSubwindowParent *temp_pointer=(ConfigureGuiSubwindowParent *) (main_treebook->GetPage(pade_id));
    bool we_can_change_tab= temp_pointer->AskUserToSaveChangesIfAny();
    if(we_can_change_tab)
        {
        event.Skip();
        }
    else
        {
        event.Veto();
        }
    }


}}// namespaces
