/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "ConfigureGuiSubwindowParent.h"
#include <iostream>
#include "DEBUGMESSAGE.h"
#include "Configure_tabs_parent.h"
#include <wx/msgdlg.h>
#include <wx/log.h>

namespace Khz{namespace CfgWin{

ConfigureGuiSubwindowParent::ConfigureGuiSubwindowParent(wxWindow *parent)
:wxPanel(parent, wxID_ANY)
    {
    notebook = new wxNotebook(this, wxID_ANY);
    wxBoxSizer *main_sizer=new wxBoxSizer(wxHORIZONTAL);
    main_sizer->Add(notebook, 1, wxEXPAND);
    SetSizerAndFit(main_sizer);
    Bind(wxEVT_NOTEBOOK_PAGE_CHANGING , &ConfigureGuiSubwindowParent::OnTabChanging, this);
    }

void ConfigureGuiSubwindowParent::OnTabChanging(wxBookCtrlEvent &event)
    {
    int pade_id=event.GetOldSelection();
    if(pade_id== wxNOT_FOUND) return;
    KHZNIK_DEBUGMESSAGE(std::cout << "ConfigureGui_main_window: OnTabChanging called, id is "<< pade_id << "\n";)
    KHZNIK_DEBUGMESSAGE(std::cout << "ConfigureGui_main_window: tabs count is "<< notebook->GetPageCount() << "\n";)
    wxWindow *temp_pointer=notebook->GetPage(pade_id);
    if(   ((Configure_gui_tabs_parent *)temp_pointer)->IsModified  )
        {
         wxMessageDialog message(this,
                                    wxString("You have modified something here. Do you want to save changes?"),
                                    wxString("Attension"),
                                     wxYES_NO|wxCENTRE|wxSTAY_ON_TOP|wxCANCEL, wxDefaultPosition) ;

        switch ( message.ShowModal() )
            {
            case wxID_YES:
                {
                ((Configure_gui_tabs_parent *)temp_pointer)->write_changes_to_config();
                ((Configure_gui_tabs_parent *)temp_pointer)->send_reconfigure_panels_event();
                ((Configure_gui_tabs_parent *)temp_pointer)->IsModified = false;
                break;
                }

            case wxID_NO:
                {
                ((Configure_gui_tabs_parent *)temp_pointer)->restore_values();
                break;
                }
            case wxID_CANCEL:
                {
                event.Veto();
                break;
                }
            default:
                wxLogError(wxT("Unexpected wxMessageDialog return code!"));
            }
        temp_pointer=NULL;
        }
    else
        {
        event.Skip();
        }
    }

bool ConfigureGuiSubwindowParent::AskUserToSaveChangesIfAny()
    {
    wxWindow *temp_pointer=notebook->GetCurrentPage();
    if(   ((Configure_gui_tabs_parent *)temp_pointer)->IsModified  )
        {
         wxMessageDialog message(this,
                                    wxString("You have modified something here. Do you want to save changes?"),
                                    wxString("Attension"),
                                     wxYES_NO|wxCENTRE|wxSTAY_ON_TOP|wxCANCEL, wxDefaultPosition) ;

        switch ( message.ShowModal() )
            {
            case wxID_YES:
                {
                ((Configure_gui_tabs_parent *)temp_pointer)->write_changes_to_config();
                ((Configure_gui_tabs_parent *)temp_pointer)->send_reconfigure_panels_event();
                ((Configure_gui_tabs_parent *)temp_pointer)->IsModified = false;
                return true;
                }

            case wxID_NO:
                {
                ((Configure_gui_tabs_parent *)temp_pointer)->restore_values();
                return true;
                }
            case wxID_CANCEL:
                {
                return false;
                }
            default:
                {
                wxLogError(wxT("Unexpected wxMessageDialog return code!"));
                return false;
                }
            }
        }
    else return true;
    }


}}// namespaces
