/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef KOLKHOZNIK_CONFIGUREGUISUBWINDOWPARENT_HEADER_INCLUDED
#define KOLKHOZNIK_CONFIGUREGUISUBWINDOWPARENT_HEADER_INCLUDED

#include <wx/panel.h>
#include <wx/notebook.h>
#include <wx/sizer.h>
#include <iostream>
namespace Khz{namespace CfgWin{


/**
@brief parent class for all of the subwindows (see #Khz::CfgWin detailed description for details)
**/
class ConfigureGuiSubwindowParent : public wxPanel
{
public:
    /**
    Constructor
    @param parent standard wxwidgets parent
    **/
    ConfigureGuiSubwindowParent(wxWindow *parent);

    /**
    Checks if the currently active tab have some
    modifications of the config parameteres.
    If there are modifications, than this function asks user to
    save changes

    @return true if user did NOT press cancel to "Do you want to save changes" answer. False otherwise.
    **/
    bool AskUserToSaveChangesIfAny();




//    /**
//    Calls SetMinSize for every Sizer of every tab and resizes content of the tabs
//    **/
//    void SetAllTabsSizersMinSizeAndFitAgain(int x, int y)
//        {
//        int tubs_num=notebook->GetPageCount();
//        for (int i=0;i<tubs_num;i++)
//            {
//             notebook->GetPage(i)->SetClientSize(wxSize(x,y));
//             notebook->GetPage(i)->GetSizer()->SetMinSize(wxSize(x,y));
//             //notebook->GetPage(i)->GetSizer()->SetSizeHints(notebook->GetPage(i) );
//             notebook->GetPage(i)->GetSizer()->Layout();
//             //notebook->GetPage(i)->Refresh();
//             //notebook->GetPage(i)->GetSizer()->Fit(notebook->GetPage(i));
//             //notebook->GetPage(i)->SendSizeEvent();
//
//            }
//        }
//
//
//    wxSize GetNotebookClientSize()
//        {
//        return notebook->GetClientSize();
//        }
//
//
//    /**
//    returns wxSize whoose x is the width of the widest tab,
//    and y is the height of highest tab
//    **/
//    wxSize GetTotalMaxTabSize()
//        {
//        int tubs_num=notebook->GetPageCount();
//
//
//        int final_x=0;
//        int final_y=0;
//
//        for (int i=0;i<tubs_num;i++)
//            {
//             wxSize cur_tab_size=notebook->GetPage(i)->GetSizer()->GetSize();
//             final_x=std::max(final_x, cur_tab_size.GetWidth());
//             final_y=std::max(final_y, cur_tab_size.GetHeight());
//            }
//        return wxSize(final_x, final_y);
//        }
//    void LayoutAllTAbs()
//        {
//        notebook->Layout();
//         int tubs_num=notebook->GetPageCount();
//        for (int i=0;i<tubs_num;i++)
//            {
//             notebook->GetPage(i)->Layout();
//            }
//        }
//    void PrintSizes()
//        {
//         int tubs_num=notebook->GetPageCount();
//
//
//        int final_x=0;
//        int final_y=0;
//
//        for (int i=0;i<tubs_num;i++)
//            {
//
//             std::cout << notebook->GetPageText(i) << "\n";
//             wxSize win_size=notebook->GetPage(i)->GetClientSize();
//             std::cout << "page size client " << win_size.GetWidth() << " " << win_size.GetHeight() << "\n";
//
//
//             wxSize win_size2=notebook->GetPage(i)->GetSize();
//             std::cout << "page size client " << win_size2.GetWidth() << " " << win_size2.GetHeight() << "\n";
//
//             wxSize sizer_size=notebook->GetPage(i)->GetSizer()->GetSize();
//             std::cout << "sizer's size " << sizer_size.GetWidth() << " " << sizer_size.GetHeight() << "\n";
//
//             wxSize sizer_minsize=notebook->GetPage(i)->GetSizer()->GetMinSize();
//             std::cout << "sizer's minsize " << sizer_minsize.GetWidth() << " " << sizer_minsize.GetHeight() << "\n";
//             std::cout << "\n\n\n";
//
//            }
//        }
protected:


    /**
    Ask user to save changes if user switches a tab within subwindow
    **/
    virtual void OnTabChanging(wxBookCtrlEvent &event);


    /**
    Notebook that contain all of the tabs of the subwindow.
    For example, #Khz::CfgWin::ConfigureGuiSubwindow_full_text_search_indexer_params class (child of this class)
    puts #Khz::CfgWin::ConfigureGuiSubwindow_full_text_search_indexer_params::archive_extractor_tab and
    #Khz::CfgWin::ConfigureGuiSubwindow_full_text_search_indexer_params::text_extractor_tab to this notebook.


    **/
    wxNotebook *notebook;
};

}}// namespaces

#endif
