/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



#include "ConfigureGuiSubwindowParent.h"
#include "CfgTabFullTextSearchArchiveExtractor.h"
#include "CfgTabFullTextSearchTextExtractor.h"


namespace Khz{namespace CfgWin{

/**
@brief "Full text search indexer params" subwindow of the configuration window

This subwindow contain two tabs: "Text layer extractor" and "Archive extractor".

**/
class ConfigureGuiSubwindow_full_text_search_indexer_params : public ConfigureGuiSubwindowParent
{
public:

    /**
    costructor
    @param parent standard wxwidgets parent
    @param path_to_config full path to the main config file
    **/
    ConfigureGuiSubwindow_full_text_search_indexer_params(wxWindow *parent, wxString path_to_config);
private:

    /**
    "Archive extractor" tab
    **/
    CfgTabFullTextSearchArchiveExtractor *archive_extractor_tab;


    /**
    "Text layer extractor" tab
    **/
    CfgTabFullTextSearchTextExtractor *text_extractor_tab;
};


}}// namespaces
