/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/




#include "ConfigureGuiSubwindowParent.h"
#include "CfgTabPathsChooser.h"
#include "CfgTabDefaultApps.h"
namespace Khz{namespace CfgWin{



/**
@brief "General" subwindow of the configuration window
**/
class ConfigureGuiSubwindow_general : public ConfigureGuiSubwindowParent
{
public:
        /**
        Constructor, cretes the configuration window.
        @param parent standard wxwidgets parent
        @param path_to_config path to the kolkhoznik config file
        **/
        ConfigureGuiSubwindow_general(wxWindow *parent, wxString path_to_config );

        /**
        "Paths" tab of the configure gui window. User can choose both database and library directory here.
        **/
        CfgTabPathsChooser *paths;


        /**
        "Extensions" tab of the configure gui window.
        User can set the default application to open a specific file extension here (for djvu, pdf and so on files).
        **/
        CfgTabDefaultApps *apps_window;

private:
    /**
    Config assiciated with the main config file.
    **/
    wxFileConfig *config;


    //void OnTabChanging(wxBookCtrlEvent &event);
};

}}// namespaces
