/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "ConfigureGuiSubwindowParent.h"
#include "CfgTabFieldsChooser.h"
#include "CfgTabFontsChooser.h"
#include "CfgTabIconsChooser.h"
#include "CfgTabAdvanced.h"
namespace Khz{namespace CfgWin{

/**
@brief "Main window" subwindow of the configuration window

**/
class ConfigureGuiSubwindow_main_window : public ConfigureGuiSubwindowParent
{
public:
        /**
        Constructor, cretes the configuration window.
        @param parent standard wxwidgets parent.
        @param path_to_config path to the kolkhoznik config file
        **/
        ConfigureGuiSubwindow_main_window(wxWindow *parent, wxString path_to_config );

        /*
        "Paths" tab of the configure gui window. User can choose both database and library directory here.
        */
        //CfgTabPathsChooser *paths;


        /*
        "Extensions" tab of the configure gui window.
        User can set the default application to open a specific file extension here (for djvu, pdf and so on files).
        */
        //CfgTabDefaultApps *apps_window;

        /**
        "Visible Fields" tab. User can choose columns (like Author, title)
        that are to be displayed on the right panel.
        **/
        CfgTabFieldsChooser *fields_window;

        /**
        "Fonts" tab. User can configure fonts of the application here.
        **/
        CfgTabFontsChooser *fonts_window;

        /**
        "Icons" tab. User can configure icons here.
        **/
        CfgTabIconsChooser *icons_window;

        /**
        "Advanced" tab.
        **/
        CfgTabAdvanced *CfgTabAdvanced_window;

private:
    /**
    Config assiciated with the main config file.
    **/
    wxFileConfig *config;

    /*
    Closes the configuration window. Event myst have id=my_wx_id__MANUAL_CLOSE_EVENT.
    @param event event is generated by Configure_gui_tabs_parent::send_close_event_manually ( ). Just call this function
    to close the window.
    */
    //void on_close_event(wxCommandEvent &event);

    /*
    Gathers together all of the tabs of the window.
    */
    //wxNotebook *notebook;

    /*
    Shows popup message
    asking user to save or discard changes (if there are modifications).
    @param event is generated by wxWidgets automaticall when changing an active tab.
    */
    //void OnTabChanging(wxBookCtrlEvent &event);
};


}}// namespaces
