/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



#include <wx/defs.h>
#include "Custom_IDs.h"
#include <wx/window.h>
#include <wx/fileconf.h>
#include "Configure_tabs_parent.h"


namespace Khz{namespace CfgWin{


Configure_gui_tabs_parent::Configure_gui_tabs_parent(wxWindow* parent,  wxString path_to_config)
    : wxWindow(parent, wxID_ANY)
    {
    wxSetlocale(LC_ALL, ""); //this is needed to non-latin characters support in paths;
    config_file=path_to_config;
    config =new wxFileConfig( "", "", path_to_config);

    //#################################################################################################
    ReconfigureType=Khz::my_wx_id__RECONFIGURE_EVERYTHING;
    //defines type of panels reconfiguration(complete, including database change, only appearance
                                                               //without database changing)
    //##################################################################################################
    IsModified=false;
    }

void Configure_gui_tabs_parent::send_close_event_manually()
        {
        wxCommandEvent event_to_propagate=wxCommandEvent( wxEVT_BUTTON);
        event_to_propagate.SetId(Khz::my_wx_id__MANUAL_CLOSE_EVENT);
        ProcessWindowEvent 	( 	event_to_propagate	) ;
        }
void Configure_gui_tabs_parent::send_reconfigure_panels_event()
    {
    wxCommandEvent event_to_propagate=wxCommandEvent( wxEVT_BUTTON);
    event_to_propagate.SetId(Khz::my_wx_id__RECONFIGURE_PANELS);
    event_to_propagate.SetInt(ReconfigureType);
    ProcessWindowEvent 	( 	event_to_propagate	) ;
    }


}}// namespaces
