/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <wx/listbox.h>
#include <wx/image.h>
#include "my_TaskBar.h"
#include <wx/bitmap.h>
#include <wx/settings.h>
#include <wx/app.h>
#include "TreeCtrlLibrary.h"
#include "MyleftPanel.h"
#include "MyMainWindow.h"
#include "wx/splash.h"
#include "ConfigManager.h"
#include "platform_specific_defs.h"


#include "FullTextSearchIndexerWindow.h"



/////////////////////////////////////////////////////////
namespace Khz{ namespace Executables{
/////////////////////////////////////////////////////////

/**
@brief The KolkhoznikFullTextSearchIndexer executable

Wxwidgets analog of the main function. Can be found in the KolkhoznikFullTextSearchIndexer.cpp file.
**/
class KolkhoznikFullTextSearchIndexer : public wxApp
    {
    public:

         /**
         standard wxApp Oninit() function
         **/
         bool OnInit();

         /**
         The indexer window
         **/
         Khz::FTS::Gui::FullTextSearchIndexerWindow *only_frame;
    };


bool KolkhoznikFullTextSearchIndexer::OnInit()
    {
    if(argc>1)
        {
        Khz::ConfigManager::SetStaticPathToConfig(argv[1]);
        }
    else
        {
        Khz::ConfigManager::SetStaticPathToConfig(); //default value
        };

    only_frame=new Khz::FTS::Gui::FullTextSearchIndexerWindow(NULL, "Generate the full text search index");
    only_frame->Show(true);


    return true;
    }


/////////////////////////////////////////
}}// namespace
/////////////////////////////////////////

IMPLEMENT_APP(Khz::Executables::KolkhoznikFullTextSearchIndexer)
