/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/




#include <string>
#include <vector>
#include <wx/string.h>
#include <wx/process.h>
#include <wx/txtstrm.h>
#include <wx/filename.h>
#include <wx/msgdlg.h>
#include "TextFromFileExtractor_parent.h"
#include <iostream>
#include "DEBUGMESSAGE.h"

namespace Khz{ namespace FTS { namespace Engine{


bool TextFromFileExtractor_parent::ExecCommandAndSaveResults(std::string cmd)
    {

	KHZNIK_DEBUGMESSAGE (std::cout << "\n executing command: " << cmd << "\n";)
    FILE* pipe = popen(cmd.c_str(), "r");
    if (!pipe) return false;
    char buffer[128];
    result_of_text_extraction = "";
    while(!feof(pipe)) {
    	if(fgets(buffer, 128, pipe) != NULL)
    		result_of_text_extraction += buffer;
    }
    pclose(pipe);

    return true;


    //std::cout << "\n TextFromFileExtractor_parent res is \n\n\n" << result_of_text_extraction<< "\n\n\n";




/*
using namespace boost::process;
using namespace boost::process::initializers;
using namespace boost::iostreams;



std::cout << "\nTextFromFileExtractor_parent: args are:\n";
for(int i=0;i<args.size();i++) std::cout << args[i] << "\n";
boost::process::pipe p = boost::process::create_pipe();
    {
    std::string cmd_line="\""+args[0]+"\"" + " " +"\""+args[1]+"\"";
    file_descriptor_sink sink(p.sink, close_handle);
    execute(
        run_exe(args[0]),
         set_cmd_line(cmd_line.c_str()),
             bind_stdout(sink)
           );
    }

file_descriptor_source source(p.source, close_handle);
stream<file_descriptor_source> is(source);
std::string s;
this->result_of_text_extraction="";
while(std::getline(is, s))
    {
    this->result_of_text_extraction=this->result_of_text_extraction+s;
    }


*/


/*    ///////////////////////////////////////////////////////////////////
    //          Executing command by wxWidgets stuff
    //          (i have no idea how this works, found in the internet)
    /////////////////////////////////////////////////////////////////////
    wxProcess *p;
    p=new wxProcess();
    p->Redirect();
    std::cout << "\n executing " << cmd << "\n";
    wxExecute(cmd, wxEXEC_SYNC, p);


    wxInputStream *i = p->GetInputStream();
    if(i)
        {

        wxTextInputStream t(*i, " \t", encoding);


        while(!i->Eof())
            {

            //reading line from the output of the commaand executiion
            wxString temp_str=t.ReadLine();


            // Saving result line by line
            this->result_of_text_extraction=result_of_text_extraction + "\n" + std::string(temp_str.ToUTF8());

            // We should not index the pages of the books. Is line consists of numbers only,
            // than we assume that this is the page number. So we drop this line

             if (!wxStringCheck<wxIsdigit>(temp_str))  // at least one character of temp_str is not a digit
                {
                this->result_of_text_extraction_for_indexing=result_of_text_extraction_for_indexing + " " + temp_str;
                }

            }

        }
delete p;
*/
}



bool TextFromFileExtractor_parent::FileExist(std::string file)
    {
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Check if test_file and file_with_expected_result are presented.
    //  It there is a problem, than we show an error message and return false.
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    if(!wxFileExists(file)  or   !wxFileName::IsFileReadable(file))
            {
            wxString message= "TextFromFileExtractor: file \""+file+"\" cannot be read";

            wxMessageBox(message, wxT("Error"), wxOK | wxICON_ERROR);
            return false;
            }
    return true;
    //////////////////////////////////////////////////////////////////////////////////
    //      Finished
    /////////////////////////////////////////////////////////////////////////////////////////////////
    }


}}}// namespaces
