/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "MyProgressDialog.h"
#include <wx/sizer.h>
namespace Khz{namespace FTS {namespace Gui{


MyProgressDialog::MyProgressDialog(wxWindow *parent, wxWindowID id, const wxString title, wxString top_message):
    wxDialog(parent, id, title)
    {
    cancel_was_pressed=false;
    cancel_button = new wxButton(this, wxID_CANCEL);
    cancel_button->SetLabel("Stop now, continue later");

    progress_bar= new wxGauge(this, wxID_ANY, 100);
    message = new wxStaticText(this, wxID_ANY, "");


    wxBoxSizer *main_sizer = new wxBoxSizer(wxVERTICAL);
    main_sizer->Add(new wxStaticText(this, wxID_ANY, top_message), 0, wxALL, 15);
    main_sizer->Add(progress_bar, 1, wxALL|wxEXPAND, 5);
    main_sizer->Add(message, 1, wxEXPAND|wxALL, 5);
    main_sizer->Add(cancel_button, 0, wxALL|wxALIGN_RIGHT, 5);


    cancel_button->Bind(wxEVT_BUTTON, &MyProgressDialog::OnCancelPressed, this);
    cancel_button->Bind(wxEVT_KEY_DOWN, &MyProgressDialog::OnKeyboardButtonPressed, this);
    cancel_button->Bind(wxEVT_KEY_UP, &MyProgressDialog::OnKeyboardButtonPressed, this);
    SetSizerAndFit(main_sizer);
    this->Show();
    }

bool MyProgressDialog::Update(int percents, wxString message)
    {
    if(cancel_was_pressed) return false;

    progress_bar->SetValue(percents);
    this->message->SetLabel(message);
    return true;
    }

void MyProgressDialog::OnCancelPressed(wxCommandEvent &event)
    {
    this->message->SetLabel("finishing, wait (could take a while)");
    cancel_was_pressed=true;
    cancel_button->Disable();
    event.StopPropagation();
    }

}}}// namespaces

