/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



#include <wx/window.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/stdpaths.h>
#include <wx/dialog.h>
#include <wx/filectrl.h>
#include <wx/filedlg.h>
//#include "MyFileDialog.h"
#include "PathToAppEntry.h"

//////////////////////////////////////////////////////////
namespace Khz{ namespace FTS { namespace Gui{
///////////////////////////////////////////////////////////



PathToAppEntry::PathToAppEntry(wxWindow *parent, wxString subscription)
    :wxWindow(parent, wxID_ANY)
    {
    input =new wxTextCtrl(this, wxID_ANY);
    select_path_button = new wxButton(this, wxID_ANY, "Choose");



    wxBoxSizer *outer_sizer=new wxBoxSizer(wxVERTICAL);
        wxBoxSizer *inner_sizer = new wxBoxSizer(wxHORIZONTAL);

    outer_sizer->Add(new wxStaticText(this, wxID_ANY,subscription));
        inner_sizer->Add(input,1, wxEXPAND | wxALL);
        inner_sizer->Add(select_path_button);
    outer_sizer->Add(inner_sizer, 0, wxALL|wxEXPAND);
    this->SetSizerAndFit(outer_sizer);


    select_path_button->Bind(wxEVT_BUTTON, &PathToAppEntry::OnSelectPathButtonPressed, this);
    }

void PathToAppEntry::OnSelectPathButtonPressed(wxCommandEvent &event)
    {
    wxString home_dir = wxStandardPaths::Get().GetDocumentsDir();
    wxFileDialog dlg(this, "Select the executable",
                     home_dir, "",
                     "", wxFD_OPEN, wxDefaultPosition);
    if(dlg.ShowModal()==wxID_CANCEL) return;

    wxString path= dlg.GetPath();
    input->SetValue(path);
    }

/////////////////////////////////////////////////////////////////////
}}}// namespaces
/////////////////////////////////////////////////////////////////////
