/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



///////////////////////////////////////////////////////
namespace Khz{ namespace FTS { namespace Gui{
///////////////////////////////////////////////////////

/**
@brief A combination of wxTextCtrl input and "Choose" button.
Allows to select the full path to the file.
**/
class PathToAppEntry : public wxWindow
{
public:

    /**
    constructor
    @param parent standard wxwidgets parent
    @param subscription message to the user. Will be shown above of the input.
    **/
    PathToAppEntry(wxWindow *parent, wxString subscription);


    /**
    Returns current value of the input
    **/
    wxString GetValue()
        {
        return input->GetValue();
        }

private:

    /**
    Input to enter the full paths
    **/
    wxTextCtrl *input;

    /**
    "Choose" button. When user presses this button, #OnSelectPathButtonPressed gets executed.
    **/
    wxButton *select_path_button;


    /**
    Opens dialog that allows user to select a file.
    Inserts the full path to the file into #input.
    Executes when user presses #select_path_button.
    **/
    void OnSelectPathButtonPressed(wxCommandEvent &event);
};


////////////////////////////////////////////////////////
}}}// namespaces
//////////////////////////////////////////////////////////
