/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/
//@QQQfinished commenting


#include <create_database.h>


namespace Khz{ namespace GenDB{

void create_dbtable_topics(sqlite3 *db)
{
    sqlite3_stmt *ppStmt1;
    sqlite3_stmt *ppStmt2;
    //sqlite3_stmt *ppStmt3;
    const char *pzTail1;
    const char *pzTail2;
    //const char *pzTail3;

    std::string query1 ="DROP TABLE IF EXISTS topics;";

    std::string query2 = "CREATE TABLE IF NOT EXISTS topics("
                    "ID INTEGER  PRIMARY KEY AUTOINCREMENT, Topic varchar(1000)"
                 // "INDEX inSHA1ofTopic(SHA1_of_Topic)"
                    ");";
    //std::string query3 = "CREATE UNIQUE INDEX IF NOT EXISTS index_IDofTopic ON topics(SHA1_of_Topic);";

    if (sqlite3_prepare_v2(db, query1.c_str(), -1, &ppStmt1, &pzTail1) != SQLITE_OK )
        {
        std::string message = sqlite3_errmsg(db);
        throw message;
        }

    else if(ppStmt1)
        {
        sqlite3_step(ppStmt1);
        sqlite3_finalize(ppStmt1);
        };



    if (sqlite3_prepare_v2(db, query2.c_str(), -1, &ppStmt2, &pzTail2) != SQLITE_OK )
        {
        std::string message = sqlite3_errmsg(db);
        throw message;
        }

    else if(ppStmt2)
        {
        sqlite3_step(ppStmt2);
        sqlite3_finalize(ppStmt2);
        }


   /* if (sqlite3_prepare_v2(db, query3.c_str(), -1, &ppStmt3, &pzTail3) != SQLITE_OK )
        {
        std::string message = sqlite3_errmsg(db);
        throw message;
        }

    else if(ppStmt3)
        {
        sqlite3_step(ppStmt3);
        sqlite3_finalize(ppStmt3);
        }
    */
        return;
}



void create_dbtable_main(sqlite3 *db)

{
    std::vector<sqlite3_stmt*> ppStmt;
    std::vector<const char*> pzTail;
    std::vector<std::string> query;

    sqlite3_stmt *ppStmt1;
    sqlite3_stmt *ppStmt2;
    sqlite3_stmt *ppStmt3;
    sqlite3_stmt *ppStmt4;
    sqlite3_stmt *ppStmt5;

    const char *pzTail1;
    const char *pzTail2;
    const char *pzTail3;
    const char *pzTail4;
    const char *pzTail5;


    ppStmt.push_back(ppStmt1);
    ppStmt.push_back(ppStmt2);
    ppStmt.push_back(ppStmt3);
    ppStmt.push_back(ppStmt4);
    ppStmt.push_back(ppStmt5);

    pzTail.push_back(pzTail1);
    pzTail.push_back(pzTail2);
    pzTail.push_back(pzTail3);
    pzTail.push_back(pzTail4);
    pzTail.push_back(pzTail5);

    std::string query1 ="DROP TABLE IF EXISTS main;";
	std::string query2 = "CREATE TABLE IF NOT EXISTS main("
	"ID INTEGER  PRIMARY KEY AUTOINCREMENT,"  //must be!!!
	"ID_of_Topic INT,"
	//"sha1_of_file,"
    "md5_of_file varchar(100),"
	//"INDEX in_SHA1_of_Topic(SHA1_of_Topic),
	"Title varchar(1000),"
	"TitleLowerCase varchar(1000),"
	"Author varchar(300),"
	"AuthorLowerCase varchar(300),"
	//"INDEX i_Author(Author),
	"Volume varchar(100),"
	"Year varchar(10),"
	"Edition varchar(60),"
	"Publisher varchar(200),"
	"Pages INT,"
	"ISBN varchar(20),"
	"ASIN varchar(20),"
	"Language varchar(20) DEFAULT 'English',"
	"Extension varchar(10),"
	"Filesize INT,"
	"Topic varchar(2000),"
	"Filename varchar(1000),"
	"DPI INT,"
	"Orientation varchar(50),"
	//"Cleaned varchar(50),"
	"Color varchar(50),"
	"OCR varchar(50),"
	"m_hash varchar(100)," // used only for full text search
	"RelPathToFile varchar(3000)"
	");";
	std::string query3 = "CREATE INDEX IF NOT EXISTS indexIDTOPIC ON main(ID_of_Topic);";
	std::string query4 = "CREATE INDEX IF NOT EXISTS indexAuthor ON main(AuthorLowerCase);";
    std::string query5 = "CREATE INDEX IF NOT EXISTS indexTitle ON main(TitleLowerCase);";
    std::string query6 = "CREATE INDEX IF NOT EXISTS indexTitle ON main(Hash);";


    query.push_back(query1);
    query.push_back(query2);
    query.push_back(query3);
    query.push_back(query4);
    query.push_back(query5);
    query.push_back(query6);





    for (unsigned int i =0; i< query.size(); i++)
        {
        if (sqlite3_prepare_v2(db, query[i].c_str(), -1, &(ppStmt[i]), &(pzTail[i])) != SQLITE_OK )
            {
            std::string message = sqlite3_errmsg(db);
            throw message;
            }

        else if(ppStmt[i])
            {
            sqlite3_step(ppStmt[i]);
            sqlite3_finalize(ppStmt[i]);
            }
        }
}


}} // namespaces
