/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



#include<vector>
#include<map>
#include<string>
#include<sqlite3.h>


namespace Khz{namespace Libs{ namespace DB{
    /**
    result of the database query. Assume that we have this code:
    @code
    sqlite3_stmt *stmt = NULL;
    std::string query = "SELECT * from main where Author=\"Jon\";";
    sqlite3_prepare_v2( db, query.c_str(), -1, &stmt, NULL ); //preparing the statement
    sqlite3_step( stmt ); //executing the statement
    result = Mdb::dbcontent(stmt) ;
    sqlite3_finalize(stmt);
    @endcode
     So, we can get the total books number with the author "Jon" by
     @code
     result.size(); //assume it returns 10
     @endcode
     We can get title of the 5-th row (assuming that size of the result >5 (10 in the example above))
     @code
     result[5]["Title"]; // "Title" is the column name in the database
     @endcode
     **/
     typedef std::vector< std::map<std::string,std::string> > mapDB;


     /**
     forms mapDB, see #mapDB
     @note
     Important. To use this function you must have "ID INTEGER  PRIMARY KEY AUTOINCREMENT" as first column in the database.
     (Or you can have any integer column, but fields must be filled).
        <br>
     P.S. May be there is a way to get rid of this requirement, but for now i do not know a such way.

     **/
     mapDB dbcontent(sqlite3_stmt *stmt);

}}}// namespaces
