/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/
//@QQQfinished commenting


#include "get_from_db.h"
#include "string_functions.h"
#include <map>


namespace Khz{namespace Libs{ namespace DB{

//gets one book from db or total number of books (if num<0) that belong to the specified topic.
//P.S. We probably should divide this function to two for clarity.


show_books_in_topic::show_books_in_topic(sqlite3 *db, std::string dbtable, long int Topic_id, long long num, std::string order)
    {
    if(Topic_id<0)  // just return nothing.
        {
        total_lines=0;
        return;
        }
    try
        {
        //////////////////////////////////////////////////////////////////////////////
        //how many books with this topic are in the database(we fill this->total_lines)
        ///////////////////////////////////////////////////////////////////////////////
        std::string number_query= "SELECT COUNT(*) FROM " + dbtable + " WHERE (ID_of_Topic="+ Mstr::IntToString(Topic_id) + ") COLLATE NOCASE;";
        this->where_statement="(ID_of_Topic="+ Mstr::IntToString(Topic_id) + ")";
        sqlite3_stmt *stmt = NULL;
        int retval = sqlite3_prepare_v2(db, number_query.c_str(), -1, &stmt, 0);
        if(retval) throw(std::string("cannot connect to db in fill_database.cpp function show_books"));
        retval = sqlite3_step(stmt);
        this->total_lines = sqlite3_column_int(stmt, 0);
        sqlite3_finalize(stmt);



        if(num<0) return; // !!!!!!!   num<0 if user just want the book's number.

        ////////////////////////////////////////////////////////////////////////////////
        // Finished getting the book's number
        ///////////////////////////////////////////////////////////////////////////////

            //we should not do this normally.
        if (num>=total_lines)
            {
            std::cout << "pisdcec katenky in show";
            abort();
            }

        /////////////////////////////////////////////////////////////////////////////////////////////////
        //Now we are getting just one book from db
        //////////////////////////////////////////////////////////////////////////////////////////////////
        std::string query = "SELECT * FROM " + dbtable + " WHERE (ID_of_Topic="+ Mstr::IntToString(Topic_id) + ") "+order+" LIMIT "+Mstr::IntToString(num)+",1;";
        sqlite3_prepare_v2( db, query.c_str(), -1, &stmt, NULL );
                             //preparing the statement
        sqlite3_step( stmt ); //executing the statement
        this->result = Khz::Libs::DB::dbcontent(stmt) ;
        sqlite3_finalize(stmt);

        }
    catch(...)
        {
        total_lines=0;
        return;
        }
    }










//Get books belonging to the specified topic from db.
//num_first and num_last are supposed to be the MyBookList's item numbers.
// the query is like this: SELECT something from dbtalbes WHERE something LIMIT num_first, (1+num_last-num_first);
//you can ask: why the last argument of the LIMIT is (1+num_last-num_first)? Ok, let me explain.
//Assume that your database have 10 rows, you want to get rows 2-5 (num_first is 2, num last is 5).
//So, you have to get 4 rows (rows 2, 3, 4, 5)  from db   4=5-2+1. so, 4 is the last argument of the LIMIT. Hope this is clear.
show_books_in_topic::show_books_in_topic(sqlite3 *db, std::string dbtable, long int Topic_id, long long num_first, long long num_last, std::string order)
    {
    if(Topic_id<0)  // just return nothing.
        {
        total_lines=0;
        return;
        }
    try
        {
        sqlite3_stmt *stmt = NULL;
        std::string query = "SELECT * FROM " + dbtable + " WHERE (ID_of_Topic="+ Mstr::IntToString(Topic_id) + ") "+order+ " COLLATE NOCASE LIMIT "+Mstr::IntToString(num_first)+"," + Mstr::IntToString(1+num_last-num_first) +  ";";
        this->where_statement = "(ID_of_Topic="+ Mstr::IntToString(Topic_id) + ")";
        sqlite3_prepare_v2( db, query.c_str(), -1, &stmt, NULL );
                             //preparing the statement
        sqlite3_step( stmt ); //executing the statement
        this->result = Khz::Libs::DB::dbcontent(stmt) ;
        sqlite3_finalize(stmt);
        }
    catch(...)
        {
        total_lines=0;
        return;
        }
    }











//gets one book from db or total number of books (if num<0).
//P.S. We probably should split this function into two for clarity.
search_books::search_books(sqlite3 *db, std::string dbtable, std::string search_string,long long num, std::string search_type,
                          std::string fields_to_search, std::string order)
    {
    try
    {
        using namespace boost;
        search_string=Mstr::to_lower_case(search_string);

        //replace commas by spaces, just in case ...
        Mstr::replaceAll(search_string, ",", " ");



        //The search string consists of words divided by spaces.
        //Let us make an array of these (key)words.
        //byt firstly one needs to remove spaces in beginning and end of the search string and
        //replaces myltiply spaces between words by a single space.
        std::vector<std::string> keywords;
        keywords=Mstr::explode(" ",Mstr::trim(regex_replace(search_string, regex("\\s+", regex_constants::icase)," ")));
        std::vector<std::string> db_query_condition;
        //ok, finished



        //here we are preparing an array with equal strings, THE SIZE OF THE ARRAY IS EQUAL TO THE NUMBER OF KEYWORDS.
        for(unsigned int i=0;i<keywords.size(); i++)
            {
            db_query_condition.push_back(fields_to_search+" LIKE ?");
            }

        //now the magic begins. Let us to prepapare the query to the database (string).
        //query_part is in fact the WHERE statement for the query. (I.E. the query is something like
                                                                //SELECT ... FROM ... WHERE + query_part +
        std::string query_part;
        if (search_type=="and") {query_part = Mstr::implode(" AND ", db_query_condition);}
        else if (search_type=="or") {query_part = Mstr::implode(" OR ", db_query_condition);}
        else throw("you have to choose search type (should be \"or\" or \"and\")");



        ///////////////////////////////////////////////////////////////////////////////////
        //   THE COUNT(*) QUERY
        ////////////////////////////////////////////////////////////////////////////////////
        std::string query_with_placeholders_count = "SELECT COUNT(*)  FROM " + dbtable + " WHERE (" + query_part + ") COLLATE NOCASE";

        //just remember the WHERE statement. It is used by the bibtex generator when
        //generating bibtex database for the qurrently displayed books.
        this->where_statement= "(" + query_part + ")";

        //now we can query the database.
        sqlite3_stmt *stmt = NULL;
        int retval = sqlite3_prepare_v2(db, query_with_placeholders_count.c_str(), -1, &stmt, 0);
        if(retval) throw(std::string("cannot connect to db in fill_database.cpp function search_books"));
        for(unsigned int i=0; i< keywords.size(); i++)
            {
            sqlite3_bind_text(stmt,  i+1, ("%"+keywords[i]+"%").c_str(), -1, SQLITE_TRANSIENT);
            this->parameters_for_WHERE_placeholders.push_back("%"+keywords[i]+"%");
            }
        retval = sqlite3_step(stmt);
        this->total_lines = sqlite3_column_int(stmt, 0);
        sqlite3_finalize(stmt);

        //   user wants only the lines number (this->total_lines already set)
        if(num<0)
            {
            return;
            }
        /////////////////////////////////////////////////////////////////////////////////////////////
        // OK, got count(*)
        /////////////////////////////////////////////////////////////////////////////////////////////




        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        // selecting one book now
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        std::string query_with_placeholders = "SELECT * FROM "+dbtable+" WHERE ("+query_part+") COLLATE NOCASE "+ order+" LIMIT "+Mstr::IntToString(num)+",1;";
        //std::cout << "\n last qure" << query_with_placeholders << "\n";

        sqlite3_prepare_v2( db, query_with_placeholders.c_str(), -1, &stmt, NULL );
        for(unsigned int i=0; i< keywords.size(); i++)
            {
            sqlite3_bind_text(stmt,  i+1, ("%"+keywords[i]+"%").c_str(), -1, SQLITE_TRANSIENT);
            }
        sqlite3_step( stmt ); //executing the statement
        this->result = Khz::Libs::DB::dbcontent(stmt) ;
        sqlite3_finalize(stmt);


        }
    catch(...)
        {
        total_lines=0;
        return;
        }
    }










//Get many books based on the search string
//num_first and num_last are supposed to be the MyBookList's item numbers.
// the query is like this: SELECT something from dbtalbes WHERE something LIMIT num_first, (1+num_last-num_first);
//you can ask: why the last argument of the LIMIT is (1+num_last-num_first)? Ok, let me explain.
//Assume that your database have 10 rows, you want to get rows 3-5 (num_first is 2, num last is 5).
//So, you have to get from db 4 rows (rows 2, 3, 4, 5)   4=5-2+1. so, 4 is the last argument of the LIMIT. Hope this is clear.
search_books::search_books(sqlite3 *db, std::string dbtable, std::string search_string,long long num_first, long long num_last, std::string search_type,
                          std::string fields_to_search, std::string order)
    {
    try
        {
        if (num_last<num_first)
            {
            std::cout << "last num is less than first num in search_books function, aborted ";
            abort();
            }
        using namespace boost;
        search_string=Mstr::to_lower_case(search_string);

        //replace commas by spaces, just in case ...
        Mstr::replaceAll(search_string, ",", " ");


        //The search string consists of words divided by spaces.
        //Let us make an array of these (key)words.
        //byt firstly one needs to remove spaces in beginning and end of the search string and
        //replaces myltiply spaces between words by a single space.
        std::vector<std::string> keywords;
        keywords=Mstr::explode(" ",Mstr::trim(regex_replace(search_string, regex("\\s+", regex_constants::icase)," ")));



        //here we are preparing an array with equal strings, THE SIZE OF THE ARRAY IS EQUAL TO THE NUMBER OF KEYWORDS.
        std::vector<std::string> db_query_condition;
        for(unsigned int i=0;i<keywords.size(); i++)
            {
            db_query_condition.push_back(fields_to_search+" LIKE ?");
            }



        //now the magic begins. Let us to prepapare the query to the database (string).
        //query part is in fact the WHERE statement for the query. (I.E. the query is something like
                                                                //SELECT ... FROM ... WHERE + query_part +
        std::string query_part;
        if (search_type=="and") {query_part = Mstr::implode(" AND ", db_query_condition);}
        else if (search_type=="or") {query_part = Mstr::implode(" OR ", db_query_condition);}
        else throw("you have to choose search type (should be \"or\" or \"and\")");


        //And finally the database query
        sqlite3_stmt *stmt = NULL;
        std::string query_with_placeholders = "SELECT * FROM "+dbtable+" WHERE ("+query_part+") "+order+" COLLATE NOCASE LIMIT "+Mstr::IntToString(num_first)+"," + Mstr::IntToString(1+num_last-num_first) +  ";";
        this->where_statement="("+query_part+")";

        sqlite3_prepare_v2( db, query_with_placeholders.c_str(), -1, &stmt, NULL );
        for(unsigned int i=0; i< keywords.size(); i++)
            {
            sqlite3_bind_text(stmt,  i+1, ("%"+keywords[i]+"%").c_str(), -1, SQLITE_TRANSIENT);
            this->parameters_for_WHERE_placeholders.push_back("%"+keywords[i]+"%");
            }
        sqlite3_step( stmt ); //executing the statement
        this->result = Khz::Libs::DB::dbcontent(stmt) ;
        sqlite3_finalize(stmt);


        }
    catch(...)
        {
        total_lines=0;
        return;
        }
    }

}}}// namespaces
