/*
Copyright (C) Ivan Ivanov, 2014-2016

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <wx/textfile.h>
#include <wx/dcclient.h>
#include "MySizeFunctions.h"
namespace Khz{namespace Libs{

int MySizeFunctions::get_height_of_number_of_text_rows(int num_of_lines, const wxWindow *window)
    {
    if (num_of_lines==0) return 0;
    const wxChar* NEWLINE_CHAR = wxTextFile::GetEOL();
    wxString str="";
    for (int i=0;i<num_of_lines;i++)
        {
        str=str+NEWLINE_CHAR;
        }
    wxWindow *temp_ptr;
    temp_ptr=(wxWindow *)window;
     wxWindowDC dc(temp_ptr);
    wxSize size = dc.GetMultiLineTextExtent(str);
    return size.GetHeight();
    }


int MySizeFunctions::get_width_of_number_of_text_symbols(int num_of_symbols, const wxWindow *window)
    {
    wxString SPACE = " ";
    wxString str="";
    for (int i=0;i<num_of_symbols;i++)
        {
        str=str+SPACE;
        }
    wxWindow *temp_ptr;
    temp_ptr=(wxWindow *)window;
     wxWindowDC dc(temp_ptr);
    wxSize size = dc.GetMultiLineTextExtent(str);
    temp_ptr=NULL;
    return size.GetWidth();
    }


int MySizeFunctions::get_width_of_string(wxString str, const wxWindow *window)
    {
    wxWindow *temp_ptr;
    temp_ptr=(wxWindow *)window;
     wxWindowDC dc(temp_ptr);
    wxSize size = dc.GetMultiLineTextExtent(str);
    temp_ptr=NULL;
    return size.GetWidth();
    }

int MySizeFunctions::get_height_of_string(wxString str,  const wxWindow *window)
    {
    wxWindow *temp_ptr;
    temp_ptr=(wxWindow *)window;
     wxWindowDC dc(temp_ptr);
    wxSize size = dc.GetMultiLineTextExtent(str);
    temp_ptr=NULL;
    return size.GetHeight();
    }
}}
