/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/




#include "OpenTheBook.h"
#include <wx/msgdlg.h>


namespace Khz{namespace Libs{

void OpentheBook(wxString RelPathToFile, wxString extension, wxString filename, wxFileConfig *config )
    {
    extension =extension.Lower();
    RelPathToFile.Replace 	("/", wxFileName::GetPathSeparator() , true );
    wxString path_to_library= config->Read(wxString("PATHS/path_to_dir_with_books"),wxString(""));
    //std::cout << "path blin is" <<  path_to_library.mb_str(wxConvLocal).data() << "\n";







    if (path_to_library.Right(1)== wxFileName::GetPathSeparator() )
        {
        path_to_library=path_to_library.RemoveLast();
        }
    wxString full_path_to_book = path_to_library + RelPathToFile +  wxFileName::GetPathSeparator() +filename;

    //if file not exist show error message@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
     if(  !wxFileExists(full_path_to_book)  ||   !wxFileName::IsFileReadable(full_path_to_book)  )
        {
        wxString Message ="Cannot read file \"" + full_path_to_book +"\". Check that there is such file and you have permission to read it."+
                            +wxTextFile::GetEOL()+wxTextFile::GetEOL()+
                            "P.S. Be sure that you have specified the right directory with books. Press File->Configure->General->Paths to check the parameter.";
        wxMessageBox(Message, wxT("Error"), wxOK | wxICON_ERROR);
        return;
        }

    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    wxString app_to_open_book=config->Read("DEFAULT_APPS/"+extension, "");
    if(app_to_open_book=="")  //app for launch this file is not specified, execute defaul
        {
         // wxCharBuffer temp_char_buffer = full_path_to_book.mb_str(wxConvLocal);
         // std::cout << "\n i will try to open file " << temp_char_buffer.data() << "\n";
        if(!wxLaunchDefaultApplication(full_path_to_book))
            {
            wxMessageBox( "Your system does not know which application should be used to open files with this extension. (" + full_path_to_book +"). You could either conifigure you system or configure Kolkhoznik.",
                                    "Error", wxOK | wxICON_ERROR);
            }
        }
    else if( app_to_open_book.Find("%f") ==  wxNOT_FOUND)
        {
        wxString command=app_to_open_book + " " + "\""+full_path_to_book+"\"";
         wxExecute(command);
        }
    else // app is specified
        {
        app_to_open_book.Replace("%f", "\""+full_path_to_book+"\"");
        wxExecute(app_to_open_book);
        }
    }



void OpentheBook(wxString FullPathToFile, wxString extension, wxFileConfig *config )
    {
    extension =extension.Lower();
    wxString full_path_to_book = FullPathToFile;

    //if file not exist show error message@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
     if(  !wxFileExists(full_path_to_book)  ||   !wxFileName::IsFileReadable(full_path_to_book)  )
        {
        wxString Message ="Cannot read file \"" + full_path_to_book +"\". Check that there is such file and you have permission to read it."+
                            +wxTextFile::GetEOL()+wxTextFile::GetEOL()+
                            "P.S. Be sure that you have specified the right directory with books. Press File->Configure->General->Paths to check the parameter.";
        wxMessageBox(Message, wxT("Error"), wxOK | wxICON_ERROR);
        return;
        }

    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    wxString app_to_open_book=config->Read("DEFAULT_APPS/"+extension, "");
    if(app_to_open_book=="")  //app for launch this file is not specified, execute defaul
        {
         // wxCharBuffer temp_char_buffer = full_path_to_book.mb_str(wxConvLocal);
         // std::cout << "\n i will try to open file " << temp_char_buffer.data() << "\n";
        if(!wxLaunchDefaultApplication("\""+ full_path_to_book + "\""))
            {
            wxMessageBox( "Your system does not know which application should be used to open files with this extension. (" + full_path_to_book +"). You could either conifigure you system or configure Kolkhoznik.",
                                    "Error", wxOK | wxICON_ERROR);
            }
        }
    else if( app_to_open_book.Find("%f") ==  wxNOT_FOUND)
        {
        wxString command=app_to_open_book + " " + "\""+full_path_to_book+"\"";
         wxExecute(command);
        }
    else // app is specified
        {
        app_to_open_book.Replace("%f", "\""+full_path_to_book+"\"");
        wxExecute(app_to_open_book);
        }
    }


}}// namespaces
