/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



#include <string_functions.h>
#include <sstream>
#include "platform_specific_defs.h"
#include <cctype>
#include <unicode/unistr.h>


namespace Khz{ namespace Libs{


bool Mstr::Not_isalnum(int charr)
    {
    return !isalnum(charr);
    }





int Mstr::count_words(std::string phrase)
    {
    using namespace boost;
    // we replace multiply spaces by single space, remove spaces
    // in the beginning and in the end of the phrase.
    //Finally, we split phrase to vector consisting of words
    std::vector<std::string> words=Khz::Libs::Mstr::explode(" ",Khz::Libs::Mstr::trim(regex_replace(phrase, regex("\\s+", regex_constants::icase)," ")));
    return words.size();
    }





std::string Mstr::IntToString(int number)  //convert int to string;
    {
    std::stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
    }





std::string Mstr::IntToString(long int number)  //convert int to string;
    {
    std::stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
    }





std::string Mstr::IntToString(long long number)  //convert int to string;
    {
    std::stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
    }





std::string Mstr::IntToString(unsigned int number)  //convert int to string;
    {
    std::stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
    }



    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//replaces substring "from" by a substring "to" in "str"(replaces every occurence)
void Mstr::replaceAll(std::string &str, const std::string from, const std::string to)
	{
		if(from.empty())
			return;
		size_t start_pos = 0;
		while((start_pos = str.find(from, start_pos)) != std::string::npos)
		{
			str.replace(start_pos, from.length(), to);
			start_pos += to.length(); // In case 'to' contains 'from', like replacing 'x' with 'yx'
		}
		return;
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



    // analog of the php's explode function
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
std::vector<std::string> Mstr::explode(std::string delim, std::string str, int i)
	{
		std::vector<std::string> result;
		int start_pos = 0;
		size_t old_start_pos =0;
		bool is_beginning_delim=false;
		if (i==0) {result.push_back(str); return result;};  // if i = 0 than nothing to do
		while((start_pos = str.find(delim, start_pos)) != ((int)std::string::npos) )
		{
		 //std::cout << "start pos is " << start_pos << "\n\n\n\n\n\n";
			if (i==0)
			{
				result.push_back( str.substr(old_start_pos+delim.length()));
				return result;
			};

			if (old_start_pos == 0)
			{
				if(start_pos==0)
				  {
				  result.push_back("");
				  is_beginning_delim=true;
				  }
				else
				{
				 if(!is_beginning_delim)
				    {
				    result.push_back( str.substr(old_start_pos, start_pos -old_start_pos));
				    }
				 else
				    {
				     result.push_back( str.substr( old_start_pos+delim.length(), start_pos -old_start_pos-delim.length() ));
				    }
				}
			}
			else
			{
				result.push_back( str.substr(old_start_pos+delim.length(), start_pos -old_start_pos - delim.length()));
			};
			old_start_pos = start_pos;
			start_pos += delim.length(); // In case 'to' contains 'from', like replacing 'x' with 'yx'
			i--;
			//std::cout << "i is " << i << "     start_pos is " << start_pos << "\n";

		}


		if(result.size() == 0)
            {
                result.push_back(str);
            }
        else
            {
            result.push_back( str.substr(old_start_pos+delim.length()));
            }
		return result;
}

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	std::string Mstr::trim(std::string some_string)
    { using namespace boost;
        some_string = regex_replace(some_string, regex("^\\s+", regex_constants::icase),"",regex_constants::format_first_only);
        some_string = regex_replace(some_string, regex("\\s+$", regex_constants::icase),"",regex_constants::format_first_only);
        return some_string;
    }
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

std::string Mstr::sha1(std::string str)
    {
    unsigned char hash[20];
    unsigned char *val;
    val= new unsigned char[str.length()+10];
    for (unsigned int i =0; i< str.length(); i++) val[i]= str.c_str()[i];
    SHA1(val, str.length(), hash);
    char out[41];
    for (int i = 0; i < 20; i++)
        {
        snprintf(out+i*2, 4, "%02x", hash[i]);
        }
    delete[] val;
    return std::string(out);
    }


std::string Mstr::implode(std::string separator, std::vector<std::string> array_of_strings)
    {
    std::string result ="";
    for (unsigned int i=0; i< array_of_strings.size(); i++)
        {
        if(i<array_of_strings.size()-1)
            {
            result = result + array_of_strings[i] + separator;
            }
        else
            {
            result = result + array_of_strings[i];
            }
        }
    return result;
    }






 std::string Mstr::to_lower_case(std::string some_string, bool replace_bad_symbols)
    {
	if (replace_bad_symbols)
        {
        Mstr::replaceAll(some_string, "Ё"   , "е");
        Mstr::replaceAll(some_string, "ё"   , "е");
        Mstr::replaceAll(some_string, "Й"   , "и");
        Mstr::replaceAll(some_string, "й"   , "и");
        }



    icu::UnicodeString unicode_topic=icu::UnicodeString::fromUTF8 	(some_string);
    icu::UnicodeString topic_lower = unicode_topic.toLower();
    std::string topic_lower_std;
    topic_lower.toUTF8String(topic_lower_std);

    return topic_lower_std;
    }





std::string Mstr::replace_translit_sumbols_to_ru(std::string some_string)
{
	Mstr::replaceAll(some_string, "Shch", "Щ"); Mstr::replaceAll(some_string, "shch", "щ");

	Mstr::replaceAll(some_string, "Sh"  , "Ш"); Mstr::replaceAll(some_string, "sh"  , "ш");
	Mstr::replaceAll(some_string, "Ch"  , "Ч"); Mstr::replaceAll(some_string, "ch"  , "ч");
	Mstr::replaceAll(some_string, "Ya"  , "Я"); Mstr::replaceAll(some_string, "ya"  , "я");
	Mstr::replaceAll(some_string, "Ja"  , "Я"); Mstr::replaceAll(some_string, "ja"  , "я");
	Mstr::replaceAll(some_string, "Yu"  , "Ю"); Mstr::replaceAll(some_string, "yu"  , "ю");
	Mstr::replaceAll(some_string, "Ju"  , "Ю"); Mstr::replaceAll(some_string, "ju"  , "ю");
	Mstr::replaceAll(some_string, "Zh"  , "Ж"); Mstr::replaceAll(some_string, "zh"  , "ж");
	Mstr::replaceAll(some_string, "Jo"  , "Ё"); Mstr::replaceAll(some_string, "jo"  , "ё");
	Mstr::replaceAll(some_string, "Yo"  , "Ё"); Mstr::replaceAll(some_string, "yo"  , "ё");
	Mstr::replaceAll(some_string, "E\'" , "Э"); Mstr::replaceAll(some_string, "e\'" , "э");
	Mstr::replaceAll(some_string, "E#"  , "Э"); Mstr::replaceAll(some_string, "e#"  , "э");

	Mstr::replaceAll(some_string, "A"   , "А"); Mstr::replaceAll(some_string, "a"   , "а");
	Mstr::replaceAll(some_string, "B"   , "Б"); Mstr::replaceAll(some_string, "b"   , "б");
	Mstr::replaceAll(some_string, "V"   , "В"); Mstr::replaceAll(some_string, "v"   , "в");
	Mstr::replaceAll(some_string, "G"   , "Г"); Mstr::replaceAll(some_string, "g"   , "г");
	Mstr::replaceAll(some_string, "D"   , "Д"); Mstr::replaceAll(some_string, "d"   , "д");
	Mstr::replaceAll(some_string, "E"   , "Е"); Mstr::replaceAll(some_string, "e"   , "е");
	Mstr::replaceAll(some_string, "Z"   , "З"); Mstr::replaceAll(some_string, "z"   , "з");
	Mstr::replaceAll(some_string, "I"   , "И"); Mstr::replaceAll(some_string, "i"   , "и");
	Mstr::replaceAll(some_string, "J"   , "Й"); Mstr::replaceAll(some_string, "j"   , "й");
	Mstr::replaceAll(some_string, "K"   , "К"); Mstr::replaceAll(some_string, "k"   , "к");
	Mstr::replaceAll(some_string, "L"   , "Л"); Mstr::replaceAll(some_string, "l"   , "л");
	Mstr::replaceAll(some_string, "M"   , "М"); Mstr::replaceAll(some_string, "m"   , "м");
	Mstr::replaceAll(some_string, "N"   , "Н"); Mstr::replaceAll(some_string, "n"   , "н");
	Mstr::replaceAll(some_string, "O"   , "О"); Mstr::replaceAll(some_string, "o"   , "о");
	Mstr::replaceAll(some_string, "P"   , "П"); Mstr::replaceAll(some_string, "p"   , "п");
	Mstr::replaceAll(some_string, "R"   , "Р"); Mstr::replaceAll(some_string, "r"   , "р");
	Mstr::replaceAll(some_string, "S"   , "С"); Mstr::replaceAll(some_string, "s"   , "с");
	Mstr::replaceAll(some_string, "T"   , "Т"); Mstr::replaceAll(some_string, "t"   , "т");
	Mstr::replaceAll(some_string, "U"   , "У"); Mstr::replaceAll(some_string, "u"   , "у");
	Mstr::replaceAll(some_string, "F"   , "Ф"); Mstr::replaceAll(some_string, "f"   , "ф");
	Mstr::replaceAll(some_string, "X"   , "Х"); Mstr::replaceAll(some_string, "x"   , "х");
	Mstr::replaceAll(some_string, "H"   , "Х"); Mstr::replaceAll(some_string, "h"   , "х");
	Mstr::replaceAll(some_string, "C"   , "Ц"); Mstr::replaceAll(some_string, "c"   , "ц");
	Mstr::replaceAll(some_string, "~"   , "ъ");
	Mstr::replaceAll(some_string, "Y"   , "Ы"); Mstr::replaceAll(some_string, "y"   , "ы");
	Mstr::replaceAll(some_string, "\'"  , "ь");
	Mstr::replaceAll(some_string, "#"   , "ь");
    return some_string;
}






void Mstr::translate_to_en_from_any_ONLY_ALPHABETIC_SYMBOLS(std::string &some_string)
    {
    Mstr::replaceAll(some_string, "а", "a" );   Mstr::replaceAll(some_string, "А", "A");
    Mstr::replaceAll(some_string, "б", "b" );   Mstr::replaceAll(some_string, "Б", "B");
    Mstr::replaceAll(some_string, "в", "v" );   Mstr::replaceAll(some_string, "В", "V");
    Mstr::replaceAll(some_string, "г", "g" );   Mstr::replaceAll(some_string, "Г", "G");
    Mstr::replaceAll(some_string, "д", "d" );   Mstr::replaceAll(some_string, "Д", "D");
    Mstr::replaceAll(some_string, "е", "e" );   Mstr::replaceAll(some_string, "Е", "E");
    Mstr::replaceAll(some_string, "ё", "e" );   Mstr::replaceAll(some_string, "Ё", "E");
    Mstr::replaceAll(some_string, "ж", "zh");   Mstr::replaceAll(some_string, "Ж", "Zh");
    Mstr::replaceAll(some_string, "з", "z" );   Mstr::replaceAll(some_string, "З", "Z");
    Mstr::replaceAll(some_string, "и", "i" );   Mstr::replaceAll(some_string, "И", "I");
    Mstr::replaceAll(some_string, "й", "i" );   Mstr::replaceAll(some_string, "Й", "I");
    Mstr::replaceAll(some_string, "к", "k" );   Mstr::replaceAll(some_string, "К", "K");
    Mstr::replaceAll(some_string, "л", "l" );   Mstr::replaceAll(some_string, "Л", "L");
    Mstr::replaceAll(some_string, "м", "m" );   Mstr::replaceAll(some_string, "М", "M");
    Mstr::replaceAll(some_string, "н", "n" );   Mstr::replaceAll(some_string, "Н", "N");
    Mstr::replaceAll(some_string, "о", "o" );   Mstr::replaceAll(some_string, "О", "O");
    Mstr::replaceAll(some_string, "п", "p" );   Mstr::replaceAll(some_string, "П", "P");
    Mstr::replaceAll(some_string, "р", "r" );   Mstr::replaceAll(some_string, "Р", "R");
    Mstr::replaceAll(some_string, "с", "s" );   Mstr::replaceAll(some_string, "С", "S");
    Mstr::replaceAll(some_string, "т", "t" );   Mstr::replaceAll(some_string, "Т", "T");
    Mstr::replaceAll(some_string, "у", "u" );   Mstr::replaceAll(some_string, "У", "U");
    Mstr::replaceAll(some_string, "ф", "f" );   Mstr::replaceAll(some_string, "Ф", "F");
    Mstr::replaceAll(some_string, "х", "x" );   Mstr::replaceAll(some_string, "Х", "X");
    Mstr::replaceAll(some_string, "ц", "c" );   Mstr::replaceAll(some_string, "Ц", "C");
    Mstr::replaceAll(some_string, "ч", "ch" );   Mstr::replaceAll(some_string, "Ч", "Ch");
    Mstr::replaceAll(some_string, "ш", "sh" );   Mstr::replaceAll(some_string, "Ш", "Sh");
    Mstr::replaceAll(some_string, "щ", "shch" );   Mstr::replaceAll(some_string, "Щ", "Shch");
    Mstr::replaceAll(some_string, "ъ", "" );   Mstr::replaceAll(some_string, "Ъ", "");
    Mstr::replaceAll(some_string, "ы", "y" );   Mstr::replaceAll(some_string, "Ы", "Y");
    Mstr::replaceAll(some_string, "ь", "" );   Mstr::replaceAll(some_string, "Ь", "");
    Mstr::replaceAll(some_string, "э", "E" );   Mstr::replaceAll(some_string, "Э", "E");
    Mstr::replaceAll(some_string, "ю", "yu" );   Mstr::replaceAll(some_string, "Ю", "Yu");
    Mstr::replaceAll(some_string, "я", "ya" );   Mstr::replaceAll(some_string, "Я", "Ya");

    //remove not english characters (i have no idea how this works, found in the internet)

    //READ THIS COMMENT!!!! Not_isalnum is definted at the top of this file. It is just !isalnum.
    some_string.erase(std::remove_if(some_string.begin(), some_string.end(), Mstr::Not_isalnum), some_string.end());
    }




}}//namespaces
