/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



#include<vector>
#include<string>
#include "get_from_db.h"
#include "books_cache.h"
#include <stdlib.h>  //fort abort function, it is strange but on linux everything works without this line





namespace Khz{namespace MainWin{





void books_cache::put_into_cache(sqlite3 *db, std::string dbtable, std::string search_string,long num_first,long num_last, std::string search_type,
                          std::string fields_to_search, std::string order)
    {
    //std::cout << "\n num first is "<< num_first<< " num last is "<< num_last;
    //std::cout << " cache min is "<< cached_min << " cache max is " <<  cached_max << "\n";
    if (
        (cached_min==num_first && cached_max== num_last) ||  ( cached_min< num_first && cached_max>num_last)  //already cached
        )
        {
      //  std::cout << "\n already cached\n";
        return;
        }
    //std::cout << "\n\n in put_into_cache search type is " << search_type << "\n\n";
    cache= Khz::Libs::DB::search_books(db, dbtable, search_string,num_first, num_last, search_type, fields_to_search, order).result;
    cached_min=num_first;
    cached_max=num_last;
    }



void books_cache::put_into_cache(sqlite3 *db, std::string dbtable, long int Topic_id,long num_first,long num_last, std::string order)
    {
    //std::cout << "\n num first inside cache is "<< num_first<< " num last is "<< num_last;
    //std::cout << " cache min inside cache is "<< cached_min << " cache max is " <<  cached_max << "\n";
        if (
        (cached_min==num_first && cached_max== num_last) ||  ( cached_min< num_first && cached_max>num_last)  //already cached
        )
            {
            //std::cout << "\n test cache size is " << cache.size()<< "\n";
            return;
            }
    //std::cout << "\n\n in put_into_cache search type is " << search_type << "\n\n";
    cache= Khz::Libs::DB::show_books_in_topic(db, dbtable, Topic_id,  num_first, num_last, order).result;
    //std::cout << "\n test cache size is " << cache.size()<< "\n";
    cached_min=num_first;
    cached_max=num_last;
    }




std::map<std::string,std::string> books_cache::get_cached_line(long item) const
    {
    if( item >= cached_min && item <= cached_max)
        {}
    else
        {
        std::cout << "bad item in get_cache_line, aborting";
        abort();
        }
    long temp_num = item - cached_min;
    return cache[temp_num];
    // cache is vector, starts from zero.
    }
bool books_cache::is_cached(long item) const
    {
    //std::cout << "cached min is " << cached_min <<"\n";
    //std::cout << "cached max is " << cached_max <<"\n";
  //  std::cout << "item is " << item<<"\n";
         if( item >= cached_min && item <= cached_max)
        {
        return true;
        }
     else
        {
        return false;
        }
    }


void books_cache::clear_cache()
    {
    cached_min=-1;
    cached_max=-1;
    }



}} // end of namespace
