/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/




#include "HtmlMessageBox.h"
#include <wx/html/htmlwin.h>
#include <wx/button.h>
#include <wx/sizer.h>
#include "MySizeFunctions.h"


namespace Khz{namespace PopupWins{


HtmlMessageBox::HtmlMessageBox
        (
        wxWindow *parent,
        wxWindowID id,
        wxString title,
        wxString pathToHtml,
        const wxPoint &pos,
        const wxSize &size,
        long style,
        const wxString &name
        )
    :wxDialog
        (
        parent,
        id,
        title,
        pos,
        size,
        style,
        name
        )
    {
    wxHtmlWindow *htmlwin =  new wxHtmlWindow(this, wxID_ANY);
    htmlwin->LoadPage(pathToHtml);
    wxButton *ok_button = new wxButton(this, wxID_OK);

    wxBoxSizer *only_sizer = new wxBoxSizer(wxVERTICAL);
    only_sizer->Add(htmlwin, 1, wxALL|wxEXPAND);
    only_sizer->Add(ok_button, 0, wxALL|wxALIGN_RIGHT, 10);
    SetSizerAndFit(only_sizer);
    SetSize
        (
            wxSize
                (
                Khz::Libs::MySizeFunctions::get_width_of_number_of_text_symbols(200, this),
                Khz::Libs::MySizeFunctions::get_height_of_number_of_text_rows(30,this)
                )
        );
    }


}}//namespaces
