/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/




//#include <iostream>
#include "MySizeFunctions.h"
#include <wx/filedlg.h>
#include "MyFileDialog.h"
#include <wx/sizer.h>
#include <wx/filectrl.h>

namespace Khz{namespace PopupWins{


MyFileDialog::MyFileDialog (wxWindow *parent, const wxString &message,
                      const wxString &defaultDirectory, const wxString &defaultFilename ,
                      const wxString &wildCard,
                      long style, const wxPoint &pos,
                      const wxSize &size, const wxString &name)
:wxDialog(parent,   wxID_ANY,  message,   pos,  size, wxDEFAULT_DIALOG_STYLE|wxRESIZE_BORDER,  name)
    {
    cancel_button = new wxButton(this, wxID_CANCEL);
    ok_button = new wxButton(this, wxID_OK);
    file_ctrl= new wxFileCtrl(this, wxID_ANY, defaultDirectory, defaultFilename ,
    wildCard, style);

    wxBoxSizer *only_sizer= new wxBoxSizer(wxVERTICAL);
    only_sizer->Add(file_ctrl, 1, wxEXPAND|wxALL, 5);
    //ok cancel buttons
        wxBoxSizer *buttons_sizer=new wxBoxSizer(wxHORIZONTAL);
        buttons_sizer->AddStretchSpacer ();
        buttons_sizer->Add(cancel_button);
        buttons_sizer->AddSpacer(3);
        buttons_sizer->Add(ok_button);
    only_sizer->Add(buttons_sizer,0,wxEXPAND|wxALL,5);
    this->SetSizerAndFit(only_sizer);
    //this->InvalidateBestSize();
        //this->SetMinSize(wxSize(400,400));
        this->SetInitialSize();
    //std::cout << "\nbest size "<<  this->GetBestSize 	( 		).GetHeight();
    //std::cout << "\n min size " << this->GetMinSize().GetHeight();
    ok_button->Bind(wxEVT_BUTTON, &MyFileDialog::OnOkButtonPressed, this);
    }

//void MyFileDialog::OnCancel(wxCommandEvent& event)
//    {
//    this->Close();
//    }
wxSize MyFileDialog::DoGetBestClientSize( ) const
    {
    int good_height_of_wxfilectrl= Khz::Libs::MySizeFunctions::get_height_of_number_of_text_rows(30, file_ctrl);     //height= 20 lines of text
    int final_good_height=good_height_of_wxfilectrl+3*ok_button->GetSize().GetHeight() +10;//10 is 2* border
    //std::cout << "\nfinal good height is "<< final_good_height;

    int good_width=Khz::Libs::MySizeFunctions::get_width_of_number_of_text_symbols(200, file_ctrl);
    return wxSize(good_width, final_good_height);
    }


void MyFileDialog::OnOkButtonPressed(wxCommandEvent& event)
    {
    wxString path =file_ctrl->GetPath();
    if(wxDirExists(path))
        {
        file_ctrl->SetDirectory(path);
        }
    else
        {
        event.Skip();
        }
    }

}}// namespaces
