/*
Copyright (C) Ivan Ivanov, 2014-2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <wx/window.h>
#include "sqlite3.h"
#include <wx/fileconf.h>
#include <wx/msgdlg.h>

namespace Khz{namespace PopupWins{

/**
@brief The statistics window of the program.  Appear when user presses "File->View statistics".

Shows the total number of the books in the library, the extensions statistics, the languages statistics.
**/
class StatisticsWindow
{
public:
    StatisticsWindow();
    ~StatisticsWindow();
private:

    /**
    The main database
    **/
    sqlite3 *db;  //without pointer does not work!!!!, FUCK

    /**
    Config associated with the main config file
    **/
    wxFileConfig *config;


    /**
    We should handle exceptions. For example, we should show an error message if the database specified in the config file
    does not exists. So, this functions creates the popup window
    that shows the error message.
    **/
    void ShowErrorMessage();
};

}} //end of namespace
