/*
Copyright (C) Ivan Ivanov, 2015

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/



#include "default_config_params.h"
#include "platform_specific_defs.h"


namespace Khz{


default_config_params::default_config_params()
    {
    fill_text_layer_extractors_params();
    fill_archive_extractors_commands();
    }



void default_config_params::fill_text_layer_extractors_params()
    {
     #if defined _WIN32  // maybe some params will be specific for OS in the future
        text_layer_extractors.push_back(std::make_pair("djvu", "%edjvutxt %f"));
        text_layer_extractors.push_back(std::make_pair("pdf", "%epdftotext -enc UTF-8 %f -"));

    #else // !_WIN32: Linux
        text_layer_extractors.push_back(std::make_pair("djvu", "%edjvutxt %f"));
        text_layer_extractors.push_back(std::make_pair("pdf", "%epdftotext -enc UTF-8 %f -"));
        //text_layer_extractors.push_back(std::make_pair("txt", "%ecat %f"));
    #endif
    }

void default_config_params::fill_archive_extractors_commands()
    {
    #if defined _WIN32 // maybe some params will be specific for OS in the future
        archive_extractors.push_back(std::make_pair("zip", "%e7z x %f -o%o"));
        archive_extractors.push_back(std::make_pair("tar", "%e7z x %f -o%o"));
        archive_extractors.push_back(std::make_pair("gz" , "%e7z x %f -o%o"));

    #else // !_WIN32: Linux
        archive_extractors.push_back(std::make_pair("zip", "%e7z x %f -o%o"));
        archive_extractors.push_back(std::make_pair("tar", "%e7z x %f -o%o"));
        archive_extractors.push_back(std::make_pair("gz" , "%e7z x %f -o%o"));
    #endif
    }


}// namespace
