/*
Copyright (C) Ivan Ivanov, 2014

This file is part of kolkhoznik.
kolkhoznik is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kolkhoznik is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kolkhoznik.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
@mainpage
 @section Database Database structure

 Our database consists of two tables: topics, main.
 Table "topics" have two columns: Topic, ID. Topic is stored as string, for example "/Physics/General courses".
 Table "main" have columns like "Title", "Author" and so on.
 In addition, it have a column named "ID_of_Topic". This is the ID of the topic in the "topics" table. So, to select books that belong to some topic, one
 should run the following query:
 @code
 SELECT * from main where ID_of_Topic=2; //Id=2 is just example
 @endcode

 @note Let us note that sqlite does not support a case-insensitive search for non-latin characters.
    To enable such search, we have columns like "TitleLowerCase". When searching, we transform a search
    string to the lowercase one, than we search in the *LowerCase column.




 @section Configuration Configuration
 All of the configuration parameters are stored in a single configuration file.
 The default  full path to the file is defined like
 @code
    wxString home_dir=wxStandardPaths::Get().GetUserConfigDir() + wxFileName::GetPathSeparator() + ".kolkhoznik";
    wxSTring full_path_to_config = home_dir + wxFileName::GetPathSeparator() + "config.cfg";  // final full path to the config file.
 @endcode
 When launching the program, we read this file and configure the application accordingly.
 User can specify his own config file. To do this he should launch kolkhoznik like "./kolkhoznik   /full/path/to/config/file"
**/
